(function(){
var GridViewConsts = {
 AdaptiveGroupPanelID: "DXAGroupPanel",
 AdaptiveHeaderPanelID: "DXAHeaderPanel",
 AdaptiveFooterPanelID: "DXAFooterPanel",
 AdaptiveGroupHeaderID: "DXADGroupHeader",
 AdaptiveHeaderID: "DXADHeader",
 HeaderTableID: "DXHeaderTable",
 FooterTableID: "DXFooterTable",
 FilterRowID: "DXFilterRow",
 DataRowID: "DXDataRow",
 DetailRowID: "DXDRow",
 EditingRowID: "DXEditingRow",
 EditingErrorItemID: "DXEditingErrorItem",
 EditFormTableCellID: "DXEFC",
 AdaptiveDetailRowID: "DXADRow",
 PreviewRowID: "DXPRow",
 GroupRowID: "DXGroupRow",
 GroupRowExpID: "DXGroupRowExp",
 EmptyDataRowID: "DXEmptyRow",
 FooterRowID: "DXFooterRow",
 GroupFooterRowID: "DXGFRow",
 HeaderRowID: "DXHeadersRow",
 BatchChangesPreviewGroupRowID: "DXBatchChangesPreviewGroupRow",
 CommandButtonID: "DXCBtn",
 DataRowTemplateCellID: "tcrow",
 GroupFooterRowTemplateCellID: "tcgfr",
 FooterRowTemplateCellID: "tcFooterRow",
 FilterRowTemplateCellID: "tcFR",
 CustDialogWindowID: "DXCDWindow",
 DataRowPattern: "_DXDataRow(?:-?\\d+|new)(?:_\\d+)?$",
 BandedRowPattern: "_DXDataRow(-?\\d+|new)_(\\d+)$",
 GridViewMarkerCssClass: "dxgv",
 ControlClassName: "dxgvControl",
 DataRowCssClass: "dxgvDataRow",
 GroupRowCssClass: "dxgvGroupRow",
 EmptyPagerRowCssClass: "dxgvEPDR",
 GroupFooterRowClass: "dxgvGroupFooter",
 GroupPanelCssClass: "dxgvGroupPanel",
 FooterScrollDivContainerCssClass: "dxgvFSDC",
 HeaderScrollDivContainerCssClass: "dxgvHSDC",
 HeaderCellCssClass: "dxgvHeader",
 HeaderCellEllipsisContainerCssClass: "dxgvHCEC",
 CommandColumnCellCssClass: "dxgvCommandColumn",
 IndentCellCssClass: "dxgvIndentCell",
 InlineEditCellCssClass: "dxgvInlineEditCell",
 DetailCellCssClass: "dxgvDetailCell",
 DetailIndentCellCssClass: "dxgvDIC",
 DetailButtonCellCssClass: "dxgvDetailButton",
 AdaptivityDisabledCssClass: "dxgvAdD",
 AdaptivityEnabledCssClass: "dxgvAE",
 AdaptivityWithLimitEnabledCssClass: "dxgvALE",
 AdaptiveHiddenCssClass: "dxgvAH",
 AdaptiveIndentCellCssClass: "dxgvAIC",
 AdaptiveDetailShowButtonCssClass: "dxgvADSB",
 AdaptiveDetailHideButtonCssClass: "dxgvADHB",
 AdaptiveDetailTableCssClass: "dxgvADT",
 AdaptiveDetailCaptionCellCssClass: "dxgvADCC",
 AdaptiveDetailDataCellCssClass: "dxgvADDC",
 AdaptiveDetailSpacerCellCssClass: "dxgvADSC",
 AdaptiveDetailCommandCellCssClass: "dxgvADCMDC",
 AdaptiveDetailLayoutItemContentCssClass: "dxgvADLIC",
 HorizontalExtraCellClassName: "dxgvHEC",
 HiddenHorizontalExtraCellMarkerClassName: "dxgvHHEC",
 FirstVisibleRowClassName: "dxgvFVR",
 LastVisibleRowClassName: "dxgvLVR",
 AccessibilityInvisibleRowClassName: "dxAIR",
 PageBottomVisibleCellsMarkerClassName: "dxgvPBVC",
 RemoveRightBorderClassName: "dxgRRB",
 BatchEditHiddenItemClassName: "dxgvBEHI",
 BatchEditChangesPreviewClassName: "dxgvBECP",
 BatchEditChangesPreviewScrollDivClassName: "dxgvBECPSD",
 BatchEditPreviewChangesButtonContainerClassName: "dxgvBEPCBC",
 BatchEditPreviewChangesButtonChangesIndicatorClassName: "dxgvBEPCBCI",
 UnspecifiedScrollPosition: -1
};
var GridViewRowType = { Header: 1, Filter: 2, Data: 3, Group: 4, GroupFooter: 5, Footer: 6, InlineEdit: 7, BatchEtalon: 8 };
var GridViewAdaptiveDetailButtonPosition = { None: 0, Left: 1, Right: 2 };
var ASPxClientGridView = ASPx.CreateClass(ASPxClientGridBase, {
 NewRowVisibleIndex: -2147483647,
 constructor: function(name){
  this.constructor.prototype.constructor.call(this, name);
  this.editMode = 2;
  this.enablePostponeResizing = false;
  this.FocusedRowChanged = new ASPxClientEvent();
  this.RowFocusing = new ASPxClientEvent();
  this.ColumnStartDragging  = new ASPxClientEvent();
  this.ColumnResizing  = new ASPxClientEvent();
  this.ColumnResized  = new ASPxClientEvent();
  this.ColumnMoving = new ASPxClientEvent();
  this.RowExpanding  = new ASPxClientEvent();
  this.RowCollapsing  = new ASPxClientEvent();
  this.DetailRowExpanding  = new ASPxClientEvent();
  this.DetailRowCollapsing  = new ASPxClientEvent();
  this.RowClick  = new ASPxClientEvent();
  this.RowDblClick  = new ASPxClientEvent();
  this.ContextMenu = new ASPxClientEvent();
  this.ContextMenuItemClick = new ASPxClientEvent();
  this.BatchEditRowValidating = new ASPxClientEvent();
  this.BatchEditRowInserting = new ASPxClientEvent();
  this.BatchEditRowDeleting = new ASPxClientEvent();
  this.BatchEditRowRecovering = new ASPxClientEvent();
  this.BatchEditChangesPreviewShowing = new ASPxClientEvent();
  this.BatchEditChangesPreviewShown = new ASPxClientEvent();
  this.allowFixedGroups = false;
  this.virtualScrollMode = 0;
  this.fixedColumnCount = 0;
  this.hasDetailRows = false;
  this.showDetailButton = true;
  this.showGroupButton = true;
  this.adaptiveButtonPos = GridViewAdaptiveDetailButtonPosition.None;
  this.showColumnHeaders = true;
  this.showGroupedColumns = false;
  this.hasMergedGroups = false;
  this.hasFilterRowTemplate = false;
  this.hasDataRowTemplate = false;
  this.hasGroupRowTemplate = false;
  this.hasFooterRowTemplate = false;
  this.hasGroupFooterRowTemplate = false;
  this.allowChangeColumnHierarchy = false;
  this.allowColumnClientMove = false;
  this.tableHelper = null;
  this.dragHelper = null;
  this.batchEditHelper = null;
  this.custDialogHelper = null;
  this.columnAdjustor = null;
  this.virtualScrollingDelay = 500;
  this.adaptivityMode = 0;
  this.adaptiveColumnsOrder = [];
  this.adaptivityHelper = null;
  this.enableCustDialog = false;
  this.custDialogApplyButtonName = "";
  this.custDialogCloseButtonName = "";
 },
 applyAccessibilityAttributes: function() {
  this.setAriaDescription("headerLayoutElements");
 },
 GetGroupPanelContextMenu: function() { return ASPx.GetControlCollection().Get(this.name + "_DXContextMenu_GroupPanel"); },
 GetColumnContextMenu: function() { return ASPx.GetControlCollection().Get(this.name + "_DXContextMenu_Columns"); },
 GetRowContextMenu: function() { return ASPx.GetControlCollection().Get(this.name + "_DXContextMenu_Rows"); },
 GetFooterContextMenu: function() { return ASPx.GetControlCollection().Get(this.name + "_DXContextMenu_Footer"); },
 GetGroupFooterContextMenu: function() { return ASPx.GetControlCollection().Get(this.GetGroupFooterContextMenuName()); },
 GetCustDialogWindow: function() { return ASPx.GetControlCollection().Get(this.name + "_" + GridViewConsts.CustDialogWindowID); },
 GetCustDialogHelper: function() {
  if(!this.custDialogHelper && typeof(ASPx.GridViewCustDialogHelper) != "undefined" && this.GetCustDialogWindow())
   this.custDialogHelper = this.CreateCustDialogHelper();
  return this.custDialogHelper;
 },
 CreateCustDialogHelper: function() { return new ASPx.GridViewCustDialogHelper(this); },
 GetGroupFooterContextMenuName: function() { return this.name + "_DXContextMenu_GroupFooter"; },
 GetItem: function(visibleIndex, level){
  var res = this.GetDataRow(visibleIndex, level);
  if(res == null) res = this.GetGroupRow(visibleIndex);
  return res;
 },
 GetDataItem: function(visibleIndex) { return this.GetDataRow(visibleIndex); },
 IsDataItem: function(visibleIndex) { return this.IsDataRow(visibleIndex); },
 GetRow: function(visibleIndex) { return this.GetItem(visibleIndex); },
 GetDataItemIDPrefix: function() { return GridViewConsts.DataRowID; },
 GetEmptyDataItemIDPostfix: function() { return GridViewConsts.EmptyDataRowID; },
 GetHotTrackItemPostfixes: function(){
  if(!this.HasBandedDataRows())
   return ASPxClientGridBase.prototype.GetHotTrackItemPostfixes.call(this);
  var postfixes = [ ];
  var layout = this.GetLayoutHelper().GetEtalonDataRowLayout();
  for(var i = 0; i < layout.length; i++)
   postfixes.push('_' + i);
  return postfixes;
 },
 GetEmptyDataItemCell: function() { 
  var row = this.GetEmptyDataItem();
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetDataRow: function(visibleIndex, level) {
  return this.GetChildElement(GridViewConsts.DataRowID + visibleIndex + this.GetBandedRowLevelPostfix(level));
 },
 GetDataRowSelBtn: function(index) { 
  var rowsToCheck = this.GetRowsToFindSelectButton(index);
  var idPostfix = this.GetDataRowSelBtnIDPrefix(index);
  for(var i = 0; i < rowsToCheck.length; i++) {
   var button = this.FindSelectButton(rowsToCheck[i], idPostfix);
   if(button) return button;
  }  
  return null; 
 },
 GetRowsToFindSelectButton: function(visibleIndex) {
  var rows = this.GetBandedDataRows(visibleIndex);
  if(this.HasAnyAdaptiveElement())
   rows.push(this.GetAdaptiveDetailRow(visibleIndex));
  return rows;
 },
 GetEditingRow: function(obj, level) {
  if(!this.HasBandedDataRows())
   return ASPxClientGridBase.prototype.GetEditingRow.call(this, obj);
  return ASPx.GetElementById((obj ? obj.name : this.name) + this.EditingRowID + this.GetBandedRowLevelPostfix(level));
 },
 GetEditingRowElements: function() {
  var rows = [];
  ASPx.GetNodesByPartialId(this.GetMainTable(), this.EditingRowID, rows);
  var adaptiveInlineEditRow = this.GetAdaptiveInlineEditRow();
  if(adaptiveInlineEditRow)
   rows.push(adaptiveInlineEditRow);
  return rows;
 },
 GetBatchEtalonRow: function(levelIndex) {
  var partialId = this.GetDataItemIDPrefix() + this.EtalonBatchRecordPostFix;
  return this.GetChildElement(partialId + this.GetBandedRowLevelPostfix(levelIndex));
 },
 GetBandedRowLevelPostfix: function(level){
  if(!this.HasBandedDataRows()) return "";
  if(!ASPx.IsExists(level))
   level = 0;
  return "_" + level;
 },
 GetBatchDataRow: function(visibleIndex) {   
  return this.GetDataRow(visibleIndex);
 },
 GetBatchBandedDataRows: function(visibleIndex) { 
  return this.GetBandedDataRows(visibleIndex);
 },
 GetBatchDataCell: function(visibleIndex, columnIndex) {
  var column = this.GetColumn(columnIndex);
  if(!column) return null;
  var adaptiveCell = column.adaptiveHidden ? this.GetAdaptiveCell(visibleIndex, columnIndex) : null;
  return adaptiveCell ? adaptiveCell : this.GetDataCell(visibleIndex, columnIndex);
 },
 GetBatchChangesPreviewGroupRow: function(groupIndex) { return this.GetChildElement(GridViewConsts.BatchChangesPreviewGroupRowID + groupIndex); },
 GetBatchEditPreviewChangesButtonContainer: function() { return ASPx.GetNodesByPartialClassName(this.GetMainElement(), GridViewConsts.BatchEditPreviewChangesButtonContainerClassName)[0]; },
 GetBatchEditPreviewChangesButtonChangesIndicator: function() { return ASPx.GetNodesByPartialClassName(this.GetMainElement(), GridViewConsts.BatchEditPreviewChangesButtonChangesIndicatorClassName)[0]; },
 IsBatchChagesViewMode: function () {
  var helper = this.GetBatchEditHelper();
  return helper && helper.IsChangesViewVisible();
 },
 GetRecordKeysForNavigation: function(includeDeleted) {
  if(this.IsBatchChagesViewMode())
   return this.GetBatchEditHelper().GetChangedRecordKeys();
  return this.GetRecordKeys(includeDeleted);
 },
 GetBatchChangesRecordVisibleIndices: function () {
  return this.GetBatchEditHelper().GetChangedRecordKeys().map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this));
 },
 GetEditFormTableCell: function() { return ASPx.GetElementById(this.name + "_" + GridViewConsts.EditFormTableCellID); },
 HasBandedDataRows: function() { return this.GetLayoutHelper().GetEtalonDataRowLayout().length > 1; }, 
 GetBandedDataRows: function(visibleIndex) {
  var height = this.GetLayoutHelper().GetLayoutHeight();
  var rows = ASPx.Data.Range(height, 0).map(function(i) { return this.GetDataRow(visibleIndex, i); }.bind(this));
  return rows.filter(function(row) { return !!row; });
 },
 GetBandedInlineEditRows: function() {
  var height = this.GetLayoutHelper().GetLayoutHeight();
  var rows = ASPx.Data.Range(height, 0).map(function(i) { return this.GetEditingRow(this, i); }.bind(this));
  return rows.filter(function(row) { return !!row; });
 },
 GetEditingCell: function(columnIndex) { 
  var row = this.GetEditingRow();
  var cellIndex = this.GetDataCellIndex(columnIndex);
  return row ? row.cells[cellIndex] : null;
 },
 GetEditingErrorCell: function(row) { 
  var row = row || this.GetEditingErrorItem();
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetErrorTextContainer: function(displayIn) {
  var errorRow = this.GetEditingErrorItem(displayIn);
  if(!errorRow) {
   var editRow = this.GetEditingRow(displayIn);
   if(editRow) {
    errorRow = this.CreateEditingErrorItem();
    errorRow.id = editRow.id.replace("DXEditingRow", this.EditingErrorItemID);
    this.UpdateEditingErrorRowColSpan(errorRow, editRow);
    ASPx.InsertElementAfter(errorRow, editRow);
   }
  }
  return this.GetEditingErrorCell(errorRow);
 },
 CreateEditingErrorItem: function() {
  var wrapperElement = document.createElement("div");
  var helper = this.GetStyleHelper();
  wrapperElement.innerHTML = "<table><tbody>" + helper.GetErrorItemHtml() + "</tbody></table>";
  var row = wrapperElement.firstChild.rows[0];
  for(var i = 0; i < row.cells.length; i++) {
   var cell = row.cells[i];
   var colSpan = parseInt(ASPx.Attr.GetAttribute(cell, "data-colSpan"));
   if(!isNaN(colSpan)) 
    cell.colSpan = colSpan;
  }
  return row;
 },
 UpdateEditingErrorRowColSpan: function(row, previousRow) {
  if(this.HasAnyAdaptiveElement()) {
   var errorCell = this.GetLastNonAdaptiveIndentCell(row);
   var adaptiveSampleCell = this.GetSampleAdaptiveDetailCell();
   errorCell.colSpan = adaptiveSampleCell.colSpan;
   errorCell.originalColSpan = adaptiveSampleCell.originalColSpan;
  } 
  if(this.GetFixedColumnsHelper() && this.IsEditFormEditMode()) {
   var errorCell = this.GetLastNonAdaptiveIndentCell(row);
   var editRowCell = this.GetLastNonAdaptiveIndentCell(previousRow);
   errorCell.colSpan = editRowCell.colSpan;
  }
 },
 GetCustDialogApplyButton: function() { return ASPx.GetControlCollection().Get(this.custDialogApplyButtonName); },
 GetCustDialogCloseButton: function() { return ASPx.GetControlCollection().Get(this.custDialogCloseButtonName); },
 PrepareCommandButton: function(button) {
  ASPxClientGridBase.prototype.PrepareCommandButton.call(this, button);
  if(this.enableCustDialog) {
   this.EnsureCommandButtonClickArgs(button);
   var commandName = button.gvClickArgs && button.gvClickArgs[0][0];
   if(commandName === "CustDialogApply")
    this.custDialogApplyButtonName = button.name;
   if(commandName === "CustDialogClose")
    this.custDialogCloseButtonName = button.name;
  }
 },
 GetDetailRow: function(visibleIndex) { return this.GetChildElement(GridViewConsts.DetailRowID + visibleIndex); },
 GetDetailCell: function(visibleIndex) { 
  var row = this.GetDetailRow(visibleIndex);
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetPreviewRow: function(visibleIndex) { return this.GetChildElement(GridViewConsts.PreviewRowID + visibleIndex); },
 GetPreviewCell: function(visibleIndex) { 
  var row = this.GetPreviewRow(visibleIndex);
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetSampleAdaptiveDetailRow: function() { return this.GetChildElement(GridViewConsts.AdaptiveDetailRowID); },
 GetSampleAdaptiveDetailCell: function() { 
  var row = this.GetSampleAdaptiveDetailRow();
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetAdaptiveDataRow: function(visibleIndex) { 
  var getDataItem = this.GetDataRow.aspxBind(this);
  var isValidDataItem = function(item) { return !!item; };
  var getInlineEditItem = this.GetEditingRow.aspxBind(this);
  return this.GetAdaptiveItem(visibleIndex, getDataItem, isValidDataItem, getInlineEditItem);
 },
 GetBandedAdaptiveDataRows: function(visibleIndex) {
  var getDataItem = this.GetBandedDataRows.aspxBind(this);
  var isValidDataItem = function(item) { return item && item.length; };
  var getInlineEditItem = this.GetBandedInlineEditRows.aspxBind(this);
  return this.GetAdaptiveItem(visibleIndex, getDataItem, isValidDataItem, getInlineEditItem) || [ ];
 },
 GetAdaptiveItem: function(visibleIndex, getDataItem, isValidDataItem, getInlineEditItem) {
  if(this.IsGroupRow(visibleIndex))
   return null;
  var item = getDataItem(visibleIndex);
  if(isValidDataItem(item))
   return item;
  if(this.IsInlineEditMode())
   return getInlineEditItem();
  return null;
 },
 GetAdaptiveDetailRow: function(visibleIndex, forceCreate) {
  var row = this.GetChildElement(GridViewConsts.AdaptiveDetailRowID + visibleIndex);
  if(!row && forceCreate) {
   var sampleRow = this.GetSampleAdaptiveDetailRow();
   var dataRow = null;
   if(this.HasBandedDataRows()){
    var bandedRows = this.GetBandedAdaptiveDataRows(visibleIndex);
    if(bandedRows.length)
     dataRow = bandedRows[bandedRows.length - 1];
   } else {
    dataRow = this.GetAdaptiveDataRow(visibleIndex);
   }
   if(sampleRow && dataRow) {
    row = sampleRow.cloneNode(true);
    row.id = this.name + "_" + GridViewConsts.AdaptiveDetailRowID + visibleIndex;
    this.GetLastNonAdaptiveIndentCell(row).originalColSpan = this.GetLastNonAdaptiveIndentCell(sampleRow).originalColSpan;
    this.EnsureAdaptiveDetailRowStyle(row, dataRow);
    ASPx.InsertElementAfter(row, dataRow);
    for(var i = 0; i < this.indentColumnCount; i++)
     row.cells[i].style.borderBottomWidth = dataRow.cells[i].style.borderBottomWidth;
   }
  }
  return row;
 },
 GetAdaptiveInlineEditRow: function() {
  if(!this.IsInlineEditMode() || !this.HasAdaptivity())
   return null;
  return this.GetAdaptiveDetailRow(this.editItemVisibleIndex);
 },
 GetAdaptiveHeaderContainer: function(columnIndex, adaptivePanel) { 
  if(!adaptivePanel) return null;
  var isGroupHeader = adaptivePanel === this.GetAdaptiveGroupPanel();
  var headerID = this.GetAdaptiveHeaderID(columnIndex, isGroupHeader);
  var adaptiveHeader = document.getElementById(headerID);
  if(!adaptiveHeader)
   adaptiveHeader = this.CreateAdaptiveHeader(adaptivePanel, headerID, isGroupHeader);
  return adaptiveHeader.dxHeaderContainer;
 },
 GetAdaptiveHeaderID: function(columnIndex, isGroupHeader) {
  return this.name + "_" + (isGroupHeader ? GridViewConsts.AdaptiveGroupHeaderID : GridViewConsts.AdaptiveHeaderID) + columnIndex;
 },
 CreateAdaptiveHeader: function(adaptivePanel, headerID, isGroupHeader) {
  var header = this.GetSampleAdaptiveHeader(isGroupHeader).cloneNode(true);
  header.id = headerID;
  ASPx.SetElementDisplay(header, true);
  header.dxHeaderContainer = this.FindAdaptiveHeaderContainer(header);
  adaptivePanel.appendChild(header);
  return header;
 },
 FindAdaptiveHeaderContainer: function(header) {
  var table = ASPx.GetChildByTagName(header, "TABLE", 0);
  return table.rows[0];
 },
 RemoveAdaptiveHeaders: function() {
  var columnIndices = this.GetVisibleColumnIndices();
  for(var i = 0; i < columnIndices.length; i++) {
   var column = this.GetColumn(columnIndices[i]);
   var headerID = this.GetAdaptiveHeaderID(column.index, column.groupIndex > -1);
   var header = document.getElementById(headerID);
   ASPx.RemoveElement(header);
  }
 },
 GetAdaptiveGroupPanel: function() { return this.GetChildElement(GridViewConsts.AdaptiveGroupPanelID); },
 GetAdaptiveHeaderPanel: function() { return this.GetChildElement(GridViewConsts.AdaptiveHeaderPanelID); },
 GetAdaptiveFooterPanel: function() { return this.GetChildElement(GridViewConsts.AdaptiveFooterPanelID); },
 GetSampleAdaptiveHeader: function(isGroupHeader) { return this.GetChildElement(isGroupHeader ? GridViewConsts.AdaptiveGroupHeaderID : GridViewConsts.AdaptiveHeaderID); },
 IsCellAdaptiveHidden: function(cell) {
  return ASPx.ElementContainsCssClass(cell, ASPx.GridViewConsts.AdaptiveHiddenCssClass);
 },
 IsAdaptiveDetailHideButton: function(button) {
  return ASPx.ElementContainsCssClass(button.GetMainElement(), ASPx.GridViewConsts.AdaptiveDetailHideButtonCssClass);
 },
 IsAdaptiveDetailShowButton: function(button) {
  return ASPx.ElementContainsCssClass(button.GetMainElement(), ASPx.GridViewConsts.AdaptiveDetailShowButtonCssClass);
 },
 GetAdaptiveCell: function(visibleIndex, columnIndex) {
  var adaptiveDetailsCell = this.GetAdaptiveDetailCell(visibleIndex, false);
  return adaptiveDetailsCell && adaptiveDetailsCell.adaptiveDetailsCells ? adaptiveDetailsCell.adaptiveDetailsCells[columnIndex] : null;
 },
 GetAdaptiveDetailCell: function(visibleIndex, forceCreate) { 
  var row = this.GetAdaptiveDetailRow(visibleIndex, forceCreate);
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetDetailButtonCell: function(visibleIndex, fromAdaptiveRow) {
  var row = fromAdaptiveRow ? this.GetAdaptiveDetailRow(visibleIndex) : this.GetAdaptiveDataRow(visibleIndex);
  return ASPx.GetChildByPartialClassName(row, GridViewConsts.DetailButtonCellCssClass);
 },
 GetGroupRow: function(visibleIndex) { 
  var element = this.GetChildElement(GridViewConsts.GroupRowID + visibleIndex);
  if(!element)
   element = this.GetExpandedGroupRow(visibleIndex);
  return element; 
 },
 GetGroupCell: function(visibleIndex) { 
  var row = this.GetGroupRow(visibleIndex);
  return row ? this.GetLastNonAdaptiveIndentCell(row) : null;
 },
 GetGroupLevel: function(visibleIndex){
  var group = this.GetGroupRow(visibleIndex);
  return group ? this.GetFooterIndentCount(group) : -1;
 },
 GetExpandedGroupRow: function(visibleIndex) { return this.GetChildElement(GridViewConsts.GroupRowID + "Exp" + visibleIndex); },
 GetGroupFooterRow: function(visibleIndex, level) { return this.GetChildElement(GridViewConsts.GroupFooterRowID + visibleIndex + this.GetBandedRowLevelPostfix(level)); },
 GetGroupFooterVisibleIndices: function() { 
  var ids = [].slice.call(this.GetMainTable().rows).map(function(row) { return row.id; });
  return this.GetGroupFooterVisibleIndicesCore(ids);
 },
 GetGroupFooterVisibleIndicesCore: function(ids) {
  var result = [ ];
  var regex = this.GetGroupFooterVisibleIndicesRegExp();
  for(var i = 0; i < ids.length; i++) {
   var matches = ids[i].match(regex);
   if(matches && matches[1]) {
    var index = parseInt(matches[1]);
    if(result.indexOf(index) === -1)
     result.push(index);
   }
  }
  return result;
 },
 GetGroupFooterVisibleIndicesRegExp: function() {
  var pattern = "^" + this.name + "_" + GridViewConsts.GroupFooterRowID + "(\\d+)(_(\\d+))?$";
  return new RegExp(pattern);
 },
 _isGroupRow: function(row) { return row.id.indexOf(GridViewConsts.GroupRowID) > -1; },
 IsHeaderRow: function(row) { return this.IsHeaderRowID(row.id); },
 IsHeaderRowID: function(id) { return id.indexOf(this.name + "_" + GridViewConsts.HeaderRowID) == 0; },
 IsEmptyHeaderID: function(id) { return id.indexOf(this.EmptyHeaderSuffix) > -1; },
 IsBandedDataRowID: function(id) {
  var pattern = new RegExp(this.name + GridViewConsts.BandedRowPattern);
  return pattern.test(id);
 },
 CreateEndlessPagingHelper: function(){
  return new ASPx.GridViewEndlessPagingHelper(this);
 },
 GetCssClassNamePrefix: function() { return "dxgv"; },
 GetFilterRow: function(level) { return this.GetChildElement(GridViewConsts.FilterRowID + this.GetBandedRowLevelPostfix(level)); },
 GetFilterCell: function(columnIndex) { return this.GetLayoutHelper().GetFilterCell(columnIndex); },
 GetDataCellIndex: function(columnIndex, visibleIndex) { 
  return this.GetLayoutHelper().GetDataCellIndex(columnIndex, visibleIndex);
 },
 GetColumnIndexByDataCell: function(dataCell) { 
  if(!dataCell) return -1;
  if(ASPx.IsExists(dataCell.columnIndex)) return dataCell.columnIndex;
  var dataRow = this.GetDataItemByChild(dataCell);
  var visibleIndex = dataRow ? this.getItemIndex(dataRow.id) : -1;
  var level = dataRow ? this.GetBandedDataRowLevelByID(dataRow.id) : -1;
  return this.GetLayoutHelper().GetColumnIndex(dataCell.cellIndex, visibleIndex, level);
 },
 GetColumnIndexByHeaderCell: function(headerCell){
  var match = headerCell.id.match(/_col(\d+)$/);
  if(match)
   return match[1];
  return -1;
 },
 GetDataItemByChild: function(element) { return ASPx.GetParent(element, this.IsDataItemElement.aspxBind(this)); },
 IsDataItemElement: function(item) {
  if(!item || !item.id) return false;
  var regex = new RegExp(GridViewConsts.DataRowPattern);
  return regex.test(item.id) || item.id.indexOf(GridViewConsts.BatchChangesViewRowID) > 0;
 },
 GetDataCell: function(visibleIndex, columnIndex) {
  return this.GetLayoutHelper().GetDataCell(visibleIndex, columnIndex);
 },
 GetDataCellByRow: function(row, columnIndex, visibleIndex){
  if(!row)
   return null;
  var cellIndex = this.GetDataCellIndex(columnIndex, visibleIndex);
  return (0 <= cellIndex && cellIndex < row.cells.length) ? row.cells[cellIndex] : null;
 },
 GetVisibleColumnIndices: function() { return this.GetColumnHelper().GetVisibleColumnIndices(); },
 GetArmatureCells: function(columnIndex) {
  var result = [ ];
  var cellIndex = this.GetDataCellIndex(columnIndex); 
  var tableHelper = this.GetTableHelper();
  if(tableHelper) {
   if(tableHelper.GetHeaderTable()) {
    var cells = tableHelper.GetArmatureCells(tableHelper.GetHeaderTable());
    if(cells) result.push(cells[cellIndex]);
   }
   if(tableHelper.GetContentTable()) {
    var cells = tableHelper.GetArmatureCells(tableHelper.GetContentTable());
    if(cells) result.push(cells[cellIndex]);
   }
   if(tableHelper.GetFooterTable()) {
    var cells = tableHelper.GetArmatureCells(tableHelper.GetFooterTable());
    if(cells) result.push(cells[cellIndex]);
   }
  }
  else {
   var mainTable = this.GetMainTable();
   result.push(mainTable.rows[0].cells[cellIndex]);
  }
  return result;
 },
 GetDataTableAccessibilityHeaderCells: function(columnIndex) {
  var result = [ ];
  if(this.accessibilityCompliant) {
   var cellIndex = this.GetDataCellIndex(columnIndex);
   var mainTable = this.GetMainTable();
   if(ASPx.ElementHasCssClass(mainTable.rows[1], GridViewConsts.AccessibilityInvisibleRowClassName))
    result.push(mainTable.rows[1].cells[cellIndex]);
  }
  return result;
 },
 GetLastNonAdaptiveIndentCell: function(row) {
  var count = 1;
  while(count <= row.cells.length){
   var cell = row.cells[row.cells.length - count];
   if(!ASPx.ElementHasCssClass(cell, GridViewConsts.AdaptiveIndentCellCssClass) && !ASPx.ElementHasCssClass(cell, GridViewConsts.HorizontalExtraCellClassName))
    return cell;
   count++;
  }
  return null;
 },
 GetHeaderScrollContainer:function() {
  return ASPx.GetNodeByClassName(this.GetMainElement(), GridViewConsts.HeaderScrollDivContainerCssClass);
 },
 GetFooterScrollContainer:function() {
  return ASPx.GetNodeByClassName(this.GetMainElement(), GridViewConsts.FooterScrollDivContainerCssClass);
 },
 SetHeadersClientEvents: function() {
  ASPxClientGridBase.prototype.SetHeadersClientEvents.call(this);
  if(!this.AllowResizing())
   return;
  var helper = this.GetResizingHelper();
  var attachMouseMove = function(headerCell) { 
   ASPx.Evt.AttachEventToElement(headerCell, "mousemove", function(e) { helper.UpdateCursor(e, headerCell); });
  };
  this.AttachEventToHeaderCells(attachMouseMove, false);
 },
 GetFooterRow: function(level){
  return this.GetChildElement(GridViewConsts.FooterRowID + this.GetBandedRowLevelPostfix(level));
 },
 GetFooterCell: function(columnIndex) { return this.GetLayoutHelper().GetFooterCell(columnIndex); },
 GetUserCommandNamesForRow: function() { return ASPxClientGridBase.prototype.GetUserCommandNamesForRow().concat([ "ShowAdaptiveDetail", "HideAdaptiveDetail" ]); },
 GetItemVisibleIndexRegExp: function(dataAndGroupOnly) {
  var idParts = [ GridViewConsts.DataRowID, GridViewConsts.GroupRowID + "(?:Exp)?", GridViewConsts.AdaptiveDetailRowID ];
  if(!dataAndGroupOnly) {
   idParts.push(GridViewConsts.PreviewRowID);
   idParts.push(GridViewConsts.DetailRowID);
  }
  return this.GetItemVisibleIndexRegExpByIdParts(idParts);
 },
 IsMainTableChildElement: function(src) {
  if(!src) return true;
  var tables = [ this.GetMainTable() ];
  var tableHelper = this.GetTableHelper();
  if(tableHelper) {
   tables.push(tableHelper.GetHeaderTable());
   tables.push(tableHelper.GetFooterTable());
  }
  for(var i = 0; i < tables.length; i++) {
   if(ASPx.GetIsParent(tables[i], src))
    return true;
  }
  return false;
 },
 CreateBatchEditApi: function() { return new ASPxClientGridViewBatchEditApi(this); },
 IsVirtualScrolling: function() { return this.virtualScrollMode > 0; },
 IsVirtualSmoothScrolling: function() { return this.virtualScrollMode === 2; },
 SetData: function(data){
  if(data.adaptiveModeInfo)
   this.SetAdaptiveMode(data.adaptiveModeInfo);
 },
 CreateColumn: function(prop) { return new ASPxClientGridViewColumn(prop); },
 InlineInitialize: function() {
  ASPxClientControl.prototype.InlineInitialize.call(this);
  this.GetColumnAdjustor().Initialize();
 },
 Initialize: function() {
  ASPxClientGridBase.prototype.Initialize.call(this);
  if(this.enableKeyboard) {
   this.kbdHelper = this.customKbdHelperName ? new ASPx[this.customKbdHelperName](this) : new ASPx.GridViewKbdHelper(this);
   this.kbdHelper.Init();
   ASPx.KbdHelper.RegisterAccessKey(this);
  }
  this.ResetStretchedColumnWidth();
  this.PrepareEditorsToKeyboardNavigation();
  this.AttachInternalContexMenuEventHandler();
  this.InitializeDropDownElementsScrolling();
  this.SetFixedColumnScrollableRows();
  this.PrepareFixedGroups();
  var resizingHelper = this.GetResizingHelper();
  if(resizingHelper)
   resizingHelper.Initialize();
  var custDialogHelper = this.GetCustDialogHelper();
  if(custDialogHelper)
   custDialogHelper.OnInit();
 },
 AfterInitialize: function() {
  if(this.HasAdaptivityAdjuster())
   this.GetAdaptivityAdjuster().CollapseMasterGridIfNeed(this);
  ASPxClientControl.prototype.AfterInitialize.call(this);
 },
 PrepareFixedGroups: function() {
  var helper = this.GetFixedGroupsHelper();
  if(helper)
   helper.Initialize();
 },
 InitializeDropDownElementsScrolling: function() {
  if(this.HasVertScroll()) {
   this.ScrollableContainerDropDownEditors = null;
   var vertScrollableControl = this.GetScrollHelper().GetVertScrollableControl();
   ASPx.Evt.AttachEventToElement(vertScrollableControl, "scroll", function(evt) {
    if(ASPx.Evt.GetEventSource(evt) === vertScrollableControl)
     this.AdjustDropDownElements();
   }.aspxBind(this));
  }
 },
 InitializeCommandButtonsInContainer: function(container) {
  var buttons = container.querySelectorAll("*[id*=_" + GridViewConsts.CommandButtonID + "].dxbButtonSys");
  this.cButtonIDs = ASPx.NodeListToArray(buttons).filter(function(el) { return !el.cpGVCommandButtonInitialized; }).map(function(el) { return el.id; });
  this.PrepareCommandButtons();
 },
 AttachInternalContexMenuEventHandler: function() {
  if(this.IsDetailGrid()) {
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "contextmenu", function(e) {
    var showDefaultMenu = ASPx.EventStorage.getInstance().Load(e);
    if(showDefaultMenu)
     ASPx.Evt.CancelBubble(e);
    else 
     ASPx.EventStorage.getInstance().Save(e, true);
   }.aspxBind(this), true);
  }
 },
 AdjustControlCore: function() {
  ASPxClientGridBase.prototype.AdjustControlCore.call(this);
  this.GetColumnAdjustor().AdjustColumns();
  this.CalculateAdaptivity();
  this.UpdateIndentCellWidths();
  this.ValidateColumnWidths();
  this.UpdateFixedColumnsFrozenRowWidths();
 },
 IsAdjustmentRequired: function() {
  if(ASPxClientControl.prototype.IsAdjustmentRequired.call(this))
   return true;
  var scrollHelper = this.GetScrollHelper();
  return scrollHelper ? scrollHelper.IsRestoreScrollPosition() : false;
 },
 SaveCallbackSettings: function() {
  ASPxClientGridBase.prototype.SaveCallbackSettings.call(this);
  var helper = this.GetFixedColumnsHelper();
  if(helper != null) helper.SaveCallbackSettings();
 },
 RestoreCallbackSettings: function() {
  this.ResetStretchedColumnWidth();
  this.SetFixedColumnScrollableRows();
  var fixedColumnsHelper = this.GetFixedColumnsHelper();
  if(fixedColumnsHelper != null)
   fixedColumnsHelper.RestoreCallbackSettings();
  this.SaveAdaptiveScrollTop();
  this.UpdateScrollableControls();
  if(fixedColumnsHelper != null)
   fixedColumnsHelper.HideColumnsRelyOnScrollPosition();
  this.UpdateIndentCellWidths();
  this.ValidateColumnWidths();
  ASPxClientGridBase.prototype.RestoreCallbackSettings.call(this);
 },
 SaveAdaptiveScrollTop: function() {
  this.adaptiveScrollTop = this.stateObject.scrollState ? this.stateObject.scrollState[1] : null;
 },
 ApplyAdaptiveScrollTop: function() {
  if(ASPx.IsExists(this.adaptiveScrollTop)) {
   this.SetVerticalScrollPosition(this.adaptiveScrollTop);
   this.adaptiveScrollTop = null;
  }
 },
 GetPopupEditFormHorzOffsetCorrection: function(popup) {
  var scrollHelper = this.GetScrollHelper();
  if(!scrollHelper) return 0;
  var scrollDiv = scrollHelper.GetHorzScrollableControl();
  if(!scrollDiv)  return 0;
  var horzAlign = popup.GetHorizontalAlign();
  if(ASPx.PopupUtils.IsRightSidesAlign(horzAlign) || ASPx.PopupUtils.IsOutsideRightAlign(horzAlign))
   return scrollDiv.scrollWidth - scrollDiv.offsetWidth;
  if(ASPx.PopupUtils.IsCenterAlign(horzAlign))
   return (scrollDiv.scrollWidth - scrollDiv.offsetWidth) / 2;
  return 0;
 },
 UpdateIndentCellWidths: function() {
  var tableHelper = this.GetTableHelper();
  if(tableHelper)
     tableHelper.UpdateIndentCellWidths();
 },
 UpdateFixedColumnsFrozenRowWidths: function() {
  var helper = this.GetFixedColumnsHelper();
  if(helper)
   helper.UpdateFrozenRowWidths();
 },
 OnBeforeCallbackOrPostBack: function() {
  ASPxClientGridBase.prototype.OnBeforeCallbackOrPostBack.call(this);
  this.SaveControlDimensions();
 },
 OnBeforeCallback: function(command) {
  ASPxClientGridBase.prototype.OnBeforeCallback.call(this, command);
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper && this.IsVirtualScrolling())
   scrollHelper.ClearVirtualScrollTimer();
 },
 OnAfterCallback: function() {
  ASPxClientGridBase.prototype.OnAfterCallback.call(this);
  this.GetColumnAdjustor().OnAfterCallback();
  this.SaveControlDimensions();
  this.GetContextMenuHelper().OnAfterCallack();
  var resizingHelper = this.GetResizingHelper();
  if(resizingHelper)
   resizingHelper.OnAfterCallback();
  var fixedGroupsHelper = this.GetFixedGroupsHelper();
  if(fixedGroupsHelper)
   fixedGroupsHelper.OnAfterCallback();
  this.PrepareEditorsToKeyboardNavigation();
  this.InitializeDropDownElementsScrolling();
  if(this.accessibilityCompliant)
   this.applyAccessibilityAttributes();
  var custDialogHelper = this.GetCustDialogHelper();
  if(custDialogHelper)
   custDialogHelper.OnAfterCallback();
 },
 PrepareEditorsToKeyboardNavigation: function() {
  if(!this.RequireEditorsKeyboardNavigation()) return;
  for(var i = 0; i < this.columns.length; i++) {
   this.AttachEventToEditor(this.columns[i].index, "GotFocus", function(s, e) { this.OnEditorGotFocus(s, e); }.aspxBind(this));
   this.AttachEventToEditor(this.columns[i].index, "KeyDown", function(s, e) { this.OnEditorKeyDown(s, e); }.aspxBind(this));
  }
 },
 RequireEditorsKeyboardNavigation: function() {
  return this.GetFixedColumnsHelper() && (this.IsInlineEditMode() || this.IsEditFormEditMode());
 },
 OnEditorGotFocus: function(s, e) {
  if(!this.RequireEditorsKeyboardNavigation()) return;
  this.TryMakeNeighborEditorVisible(s);
 },
 OnEditorKeyDown: function(s, e) {
  if(!this.RequireEditorsKeyboardNavigation()) return;
  var keyCode = ASPx.Evt.GetKeyCode(e.htmlEvent);
  if(keyCode !== ASPx.Key.Tab) return;
  var neighborEditor = this.GetNeighborEditor(s, e.htmlEvent.shiftKey);
  if(neighborEditor && this.TryMakeNeighborEditorVisible(neighborEditor)) {
   ASPx.Evt.PreventEventAndBubble(e.htmlEvent);
   ASPx.Selection.SetCaretPosition(s.GetInputElement());
   neighborEditor.Focus();
  }
 },
 GetNeighborEditor: function(editor, left) {
  var neighborEditor = null;
  if(this.IsEditFormEditMode()) {
   var neighborEditorIndex = this.editorIDList.indexOf(editor.name) + (left ? -1 : 1);
   var neighborEditorName = this.editorIDList[neighborEditorIndex];
   neighborEditor = ASPx.GetControlCollection().GetByName(neighborEditorName);
  } else {
   var matrix = this.GetHeaderMatrix();
   var neighborColumnIndex = left ? matrix.GetLeftNeighbor(editor.dxgvColumnIndex, true) : matrix.GetRightNeighbor(editor.dxgvColumnIndex, true);
   neighborEditor = this.GetEditorByColumnIndex(neighborColumnIndex);
  }
  return neighborEditor;
 },
 TryMakeNeighborEditorVisible: function(editor) {
  var helper = this.GetFixedColumnsHelper();
  if(this.IsEditFormEditMode())
   return helper.TryScrollToFocusedEditor(editor);
  var columnIndex = this.tryGetNumberFromEndOfString(editor.name).value;
  return helper.TryShowColumn(columnIndex, true);
 },
 IsInlineEditMode: function() { return this.editMode === 0; },
 IsEditFormEditMode: function() { return this.editMode === 1 || this.editMode === 2; },
 IsBatchEditMode: function() { return this.editMode === 4; },
 IsEditRowHasDisplayedDataRow: function() { return this.editMode >= 2; },
 canSortByColumn: function(headerElement) {
  if(this.IsBatchChagesViewMode())
   return false;
  return ASPxClientGridBase.prototype.canSortByColumn.call(this,headerElement);
 },
 canGroupByColumn: function(headerElement) {
  if(this.IsBatchChagesViewMode())
   return false;
  return this.getColumnObject(headerElement.id).allowGroup;
 },
 canDragColumn: function(headerElement) {
  if(this.IsBatchChagesViewMode() && !this.GetColumnMovingHelper())
   return false;
  var column = this._getColumnObjectByArg(this.getColumnIndex(headerElement.id));
  return !this.RaiseColumnStartDragging(column) && this.getColumnObject(headerElement.id).allowDrag;
 },
 doPagerOnClick: function(id) {
  if(!ASPx.IsExists(id)) return;
  this.AssignSlideAnimationDirectionByPagerArgument(id, this.pageIndex);
  if(ASPx.Browser.IE && this.kbdHelper)
   this.kbdHelper.Focus();
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.ResetScrollTop();
  ASPxClientGridBase.prototype.doPagerOnClick.call(this, id);
 },
 TryStartColumnResizing: function(e, headerCell) {
  var helper = this.GetResizingHelper();
  if(!helper || !helper.CanStartResizing(e, headerCell))
   return false;
  var columnIndex = helper.GetResizingColumnIndex(e, headerCell);
  var column = this.columns.filter(function(c) { return c.index == columnIndex; })[0];
  if(this.RaiseColumnResizing(column))
   return false;
  helper.StartResizing(column.index);
  return true;
 },
 IsPossibleSelectItem: function(visibleIndex, newSelectedValue){
  return this.IsDataRow(visibleIndex) && ASPxClientGridBase.prototype.IsPossibleSelectItem.call(this, visibleIndex, newSelectedValue);
 },
 _isRowSelected: function(visibleIndex) {
  return this.IsDataRow(visibleIndex) && ASPxClientGridBase.prototype._isRowSelected.call(this, visibleIndex);
 },
 GetDataItemCountOnPage: function(){
  var dataRowCount = 0;
  for(var i = 0; i < this.pageRowCount; i++){
   var index = i + this.visibleStartIndex;
   if(!this.IsGroupRow(index))
    dataRowCount++;
  }
  return dataRowCount;
 },
 RequireProcessTableClickLikeCheckBoxClick: function(tableClickSource, visibleIndex) { 
  var dataCell = this.GetLayoutHelper().GetDataCellByChild(tableClickSource);
  if(dataCell) {
   var column = this.GetColumn(this.GetColumnIndexByDataCell(dataCell));
   if(column && column.isCommandColumn) {
    var checkBoxElement = this.GetDataRowSelBtn(visibleIndex);
    return checkBoxElement && ASPx.GetIsParent(dataCell, checkBoxElement);
   }
  }
  return false; 
 },
 GetFocusedItemStyle: function(visibleIndex, focused){
  var row = this.GetItem(visibleIndex);
  if(focused && row) {
   var helper = this.GetStyleHelper();
   return this._isGroupRow(row) ? helper.GetFocusedGroupItemStyle() : helper.GetFocusedItemStyle();
  }
  return ASPxClientGridBase.prototype.GetFocusedItemStyle.call(this, visibleIndex, focused);
 },
 RequireChangeItemStyle: function(visibleIndex, itemStyle){
  if(!ASPxClientGridBase.prototype.RequireChangeItemStyle.call(this, visibleIndex, itemStyle))
   return false;
  var helper = this.GetStyleHelper();
  return !helper.IsSelectedItemStyle(itemStyle) || !this.IsGroupRow(visibleIndex); 
 },
 UpdateItemsStyle: function() {
  this.UpdateFirstAndLastVisibleRowMarkers();
  ASPxClientGridBase.prototype.UpdateItemsStyle.call(this);
 },
 GetItemStyle: function(visibleIndex){
  var style = ASPxClientGridBase.prototype.GetItemStyle.call(this, visibleIndex);
  var helper = this.GetStyleHelper();
  if(helper.IsFocusedItemStyle(style) && this.IsGroupRow(visibleIndex))
   style = helper.GetFocusedGroupItemStyle();
  return style;
 },
 ApplyItemStyle: function(visibleIndex, styleInfo) {
  if(this.HasBandedDataRows() && !this.IsGroupRow(visibleIndex)){
   var rows = this.GetBandedDataRows(visibleIndex);
   for(var i = 0; i < rows.length; i++)
    this.ApplyElementStyle(rows[i], styleInfo);
  } else
   ASPxClientGridBase.prototype.ApplyItemStyle.call(this, visibleIndex, styleInfo);
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper && !adaptivityHelper.IsResponsiveMode()) {
   if(adaptivityHelper.HasAnyAdaptiveElement() && !this.IsGroupRow(visibleIndex)) {
    var dataRows = this.HasBandedDataRows() ? this.GetBandedAdaptiveDataRows(visibleIndex) : [this.GetDataRow(visibleIndex)];
    var hideRow = function(row) { if(row) ASPx.AddClassNameToElement(row, GridViewConsts.AdaptiveHiddenCssClass); };
    dataRows.forEach(hideRow);
   }
   var adaptiveItem = this.GetAdaptiveDetailRow(visibleIndex);
   if(adaptiveItem) {
    ASPx.Attr.SaveStyleAttribute(adaptiveItem, "display");
    this.ApplyElementStyle(adaptiveItem, styleInfo);
    ASPx.Attr.RestoreStyleAttribute(adaptiveItem, "display");
   }
  }
 },
 EnsureAdaptiveDetailRowStyle: function(adaptiveRow, dataRow) {
  if(this.GetAdaptivityHelper().IsResponsiveMode()) 
   return;
  var visibleIndex = this.getItemIndex(dataRow.id);
  this.ApplyItemStyle(visibleIndex, this.GetStyleHelper().GetClearItemStyle());
  var exceptions = [ GridViewConsts.DataRowCssClass, GridViewConsts.AdaptiveHiddenCssClass, GridViewConsts.FirstVisibleRowClassName, GridViewConsts.LastVisibleRowClassName ];
  var classNames = ASPx.GetClassNameList(dataRow);
  classNames = classNames.filter(function(name) { 
   for(var i = 0; i < exceptions.length; i++) {
    if(exceptions[i].indexOf(name) > -1)
     return false;
   }
   return true; 
  });
  for(var i = 0; i < classNames.length; i++)
   ASPx.AddClassNameToElement(adaptiveRow, classNames[i]);
  adaptiveRow.style.cssText = dataRow.style.cssText + " " + adaptiveRow.style.cssText;
  this.UpdateItemStyle(visibleIndex);
 },
 OnScroll: function(evt){
 },
 getItemByHtmlEvent: function(evt) {
  return this.getItemByHtmlEventCore(evt, GridViewConsts.DataRowID) || this.getItemByHtmlEventCore(evt, GridViewConsts.GroupRowID) || this.getItemByHtmlEventCore(evt, GridViewConsts.AdaptiveDetailRowID);
 },
 IsHeaderChild: function(source) {
  if(!this.showColumnHeaders) return false;
  var headerRowCount = this.GetHeaderMatrix().GetRowCount();
  for(var i = 0; i < headerRowCount; i++) {
   if(ASPx.GetIsParent(this.GetHeaderRow(i), source))
    return true;
  }
  return false;
 },
 IsActionElement: function(mainElement, source) {
  if(this.testActionElement(source))
   return true;
  var parent = source;
  var controlCollection = ASPx.GetControlCollection();
  while(parent.id !== mainElement.id) {
   var control = controlCollection.Get(parent.id);
   if(this.IsActionClientControl(control))
    return true;
   parent = parent.parentElement;
  }  
  return false;
 },
 IsActionClientControl: function(control) {
  if(!ASPx.IsExists(control)) return false;
  var isClientButton = typeof(ASPxClientButton) !== "undefined" && control instanceof ASPxClientButton;
  var isClientEditBase = typeof(ASPxClientEditBase) !== "undefined" && control instanceof ASPxClientEditBase;
  return isClientButton || isClientEditBase;
 },
 IsDetailGridFocused: function(evt) {
  var result = false;
  var mainTable = this.GetMainTable();
  var target = ASPx.Evt.GetEventSource(evt);  
  ASPx.GetControlCollection().ForEachControl(function(control) {   
   var isDetailGrid = control instanceof ASPxClientGridView && control !== this && ASPx.GetIsParent(mainTable, control.GetMainElement());
   if(isDetailGrid) {
    var helper = control.GetCellFocusHelper();
    if(helper && ASPx.GetIsParent(helper.GetCurrentFocusedCell(), target)) {
     result = true;
     return true;
    }
   }
  }, this);
  return result;
 },
 IsMasterGridFor: function(detailGrid) {
  return ASPx.GetIsParent(this.GetMainTable(), detailGrid.GetMainElement());
 },
 NeedPreventGestures: function(element, mainElement) {
  var gridElement = ASPx.GetParent(element, function(el) { return ASPx.GetControlCollection().GetByName(el.id) instanceof ASPxClientGridView; });
  if(gridElement !== this.GetMainElement())
   return true;
  return ASPxClientGridBase.prototype.NeedPreventGestures.call(this, element, mainElement);
 },
 getItemIndex: function(rowId) {
  if(this.IsHeaderRowID(rowId))
   return -1;
  if(this.IsBandedDataRowID(rowId))
   return this.GetBandedDataRowVisibleIndexByID(rowId);
  return ASPxClientGridBase.prototype.getItemIndex.call(this, rowId);
 },
 GetBandedDataRowLevelByID: function(rowId){
  if(!rowId) return -1;
  var matches = rowId.match(this.name + GridViewConsts.BandedRowPattern);
  return matches && matches.length > 2 ? parseInt(matches[2]) : -1;
 },
 GetBandedDataRowVisibleIndexByID: function(rowId){
  if(!rowId) return -1;
  var matches = rowId.match(this.name + GridViewConsts.BandedRowPattern);
  return matches && matches.length > 2 ? parseInt(matches[1]) : -1;
 },
 CreateBatchEditHelperOwner: function() { return new ASPx.GridViewBatchEditHelperOwner(this); },
 CreateCellFocusHelper: function() { return new ASPx.GridViewCellFocusHelper(this); },
 CreateStyleHelper: function() { return new GridViewStyleHelper(this); },
 GetColumnHelper: function() {
  if(!this.columnHelper)
   this.columnHelper = new ASPx.GridViewColumnHelper(this);
  return this.columnHelper;
 },
 GetColumnMovingHelper: function() {
  if(!this.allowColumnClientMove) return;
  if(!this.columnMovingHelper && typeof(ASPx.GridViewColumnMovingHelper) != "undefined")
   this.columnMovingHelper = new ASPx.GridViewColumnMovingHelper(this);
  return this.columnMovingHelper;
 },
 GetTableHelper: function() {
  if(!this.tableHelper)
   this.tableHelper = this.CreateTableHelper(this.MainTableID, GridViewConsts.HeaderTableID, GridViewConsts.FooterTableID, this.horzScroll, this.vertScroll);
  return this.tableHelper;
 },
 CreateTableHelper: function(contentTableIDSuffix, headerTableIDSuffix, footerTableIDSuffix, horzScroll, vertScroll) {
  if(typeof(ASPx.GridViewTableHelper) != "undefined")
   return new ASPx.GridViewTableHelper(this, contentTableIDSuffix, headerTableIDSuffix, footerTableIDSuffix, horzScroll, vertScroll);
 },
 GetScrollHelper: function() {
  if(!this.HasScrolling()) return null;
  if(!this.scrollableHelper)
   this.scrollableHelper = new ASPx.GridViewTableScrollHelper(this.GetTableHelper());
  return this.scrollableHelper;
 },
 GetFixedColumnsHelper: function() {
  if(!this.GetFixedColumnsDiv()) return null;
  if(!this.fixedColumnsHelper)
   this.fixedColumnsHelper = new ASPx.GridViewTableFixedColumnsHelper(this.GetTableHelper(), this.FixedColumnsDivID, this.FixedColumnsContentDivID, this.fixedColumnCount);
  return this.fixedColumnsHelper;
 },
 GetFixedGroupsHelper: function() {
  if(!this.allowFixedGroups) return null;
  if(!this.fixedGroupsHelper)
   this.fixedGroupsHelper = new ASPx.GridViewFixedGroupsHelper(this.GetTableHelper());
  return this.fixedGroupsHelper;
 },
 GetResizingHelper: function() {
  if(!this.AllowResizing()) return null;
  if(!this.resizingHelper)
   this.resizingHelper = new ASPx.GridViewTableResizingHelper(this.GetTableHelper());
  return this.resizingHelper;
 },
 GetHeaderMatrix: function() {
  if(!this.headerMatrix)
   this.headerMatrix = new GridViewHeaderMatrix(this);
  return this.headerMatrix;
 },
 GetContextMenuHelper: function() {
  if(!this.contextMenuHelper)
   this.contextMenuHelper = this.CreateContextMenuHelper();
  return this.contextMenuHelper;
 },
 CreateContextMenuHelper: function() { return new ASPx.GridViewContextMenuHelper(this); },
 CreateLayoutHelper: function() { return new ASPx.GridViewLayoutHelper(this); },
 CreateNavigationHelper: function() { return typeof(ASPx.GridViewNavigationHelper) != "undefined" ? new ASPx.GridViewNavigationHelper(this) : null; },
 CreateFilterHelper: function() { return new ASPx.GridViewFilterHelper(this); },
 CreateCallbackHelper: function() { return new GridViewCallbackHelper(this); },
 CreateToolbarHelper: function() { return new ASPx.GridViewToolbarHelper(this); },
 Invalidate: function() {
  this.GetColumnHelper().Invalidate();
  this.GetHeaderMatrix().Invalidate();
  ASPxClientGridBase.prototype.Invalidate.call(this);
 },
 ValidateColumnWidths: function() {
  var helper = this.GetResizingHelper();
  if(helper)
   helper.ValidateColumnWidths();
 },
 ResetStretchedColumnWidth: function() {
  var helper = this.GetResizingHelper();
  if(helper)
   helper.ResetStretchedColumnWidth();
 },
 SaveControlDimensions: function() {
  var helper = this.GetResizingHelper();
  if(helper)
   helper.SaveControlDimensions(true);
 },
 AdjustDropDownElements: function() {
  var vertScrollableControl = this.GetScrollHelper().GetVertScrollableControl();
  var scrollableRect = vertScrollableControl.getBoundingClientRect();
  ASPx.Data.ForEach(this.GetDropDownEditors(), function(dropDownEditor) {
   var editorRect = dropDownEditor.GetMainElement().getBoundingClientRect();
   var editorBottomIsVisible = editorRect.top + editorRect.height < scrollableRect.bottom
    && editorRect.top + editorRect.height > scrollableRect.top;
   if(dropDownEditor.GetPopupControl().IsVisible())
    if(editorBottomIsVisible)
     dropDownEditor.AdjustDropDownWindow();
    else
     dropDownEditor.HideDropDown();
  });
 },
 GetDropDownEditors: function() {
  if(this.ScrollableContainerDropDownEditors === null) {
   var dropDownEditorPopupElementPostfixRegex = /_DDD_PW-\d+$/g;
   var controlCollection = ASPx.GetControlCollection();
   var vertScrollableControl = this.GetScrollHelper().GetVertScrollableControl();
   var popupElements = ASPx.GetNodesByClassName(vertScrollableControl, "dxpc-ddSys")
    .filter(function(element) { return element.id.match(dropDownEditorPopupElementPostfixRegex); });
   var editorNames = popupElements.map(function(element) { return element.id.replace(dropDownEditorPopupElementPostfixRegex, ""); });
   this.ScrollableContainerDropDownEditors = editorNames.map(controlCollection.GetByName.aspxBind(controlCollection));
  }
  return this.ScrollableContainerDropDownEditors;
 },
 BrowserWindowResizeSubscriber: function() {
  return this.IsFixedLayoutWithUnsetWidth() || this.enableCustDialog || ASPxClientGridBase.prototype.BrowserWindowResizeSubscriber.call(this);
 }, 
 IsFixedLayoutWithUnsetWidth: function() {
  var mainElement = this.GetMainElement();
  var mainTable = this.GetMainTable();
  if(mainElement && mainTable) {
   var mainElementStyle = ASPx.GetCurrentStyle(mainElement);
   var mainTableStyle = ASPx.GetCurrentStyle(mainTable);
   return mainTableStyle.tableLayout === "fixed" && mainElementStyle.width === "";
  }
 }, 
 OnBrowserWindowResize: function(e) {
  this.EndBatchEdit(e);
  if(this.AllowResizing() && !this.HasScrolling())
   this.ValidateColumnWidths();
  var custDialogHelper = this.GetCustDialogHelper();
  if(custDialogHelper)
   custDialogHelper.OnBrowserWindowResize(e);
  var fixedGroupsHelper = this.GetFixedGroupsHelper();
  if(fixedGroupsHelper)
   fixedGroupsHelper.OnBrowserWindowResize(e);
  this.AdjustControl();
 },
 ShowCustomizationDialog: function() {
  var window = this.GetCustDialogWindow();
  if(window)
   window.Show();
 },
 EndBatchEdit: function(e){ 
  var batchEditHelper = this.GetBatchEditHelper();
  if(this.HasAdaptivity() && batchEditHelper && e.prevWndWidth != e.wndWidth)
   batchEditHelper.EndEdit();
 },
 GetColumnAdjustor: function() {
  if(!this.columnAdjustor)
   this.columnAdjustor = this.CreateColumnAdjustor();
  return this.columnAdjustor;
 },
 CreateColumnAdjustor: function() {
  return new ASPx.GridViewColumnAdjustor(this);
 },
 GetAdaptivityHelper: function() {
  if(this.adaptivityMode === 0) return null;
  if(!this.adaptivityHelper)
   this.adaptivityHelper = this.CreateAdaptivityHelper();
  return this.adaptivityHelper;
 },
 HasAdaptivity: function() { return !!this.GetAdaptivityHelper(); },
 HasAnyAdaptiveElement: function() { 
  var helper = this.GetAdaptivityHelper();
  return helper && helper.HasAnyAdaptiveElement();
 },
 CreateAdaptivityHelper: function() {
  if(this.adaptivityMode === 1) {
   return this.GetLayoutHelper().IsFixedTableLayout()
    ? this.CreateFixedTableLayoutAdaptivityHelper()
    : this.CreateAutoTableLayoutAdaptivityHelper();
  }
  else if(this.adaptivityMode === 2)
   return this.CreateAdaptiveModeAdaptivityHelper();
  throw "Incorrect adaptivity mode.";
 },
 CreateFixedTableLayoutAdaptivityHelper: function() {
  return new ASPx.GridViewFixedTableLayoutAdaptivityHelper(this);
 },
 CreateAutoTableLayoutAdaptivityHelper: function() {
  return new ASPx.GridViewAutoTableLayoutAdaptivityHelper(this);
 },
 CreateAdaptiveModeAdaptivityHelper: function() {
  return new ASPx.GridViewAdaptiveModeAdaptivityHelper(this);
 },
 SetAdaptiveMode: function(data) {
  this.adaptivityMode = data.adaptivityMode;
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper)
   adaptivityHelper.ApplySettings(data);
 },
 IsResponsiveAdaptivityMode: function() {
  var adaptivityHelper = this.GetAdaptivityHelper();
  return adaptivityHelper && adaptivityHelper.IsResponsiveMode();
 },
 HasAdaptivityAdjuster: function() {
  return !!this.GetAdaptivityAdjuster();
 },
 GetAdaptivityAdjuster: function() {
  if(ASPx.GetGridViewAdaptivityAdjuster)
   return ASPx.GetGridViewAdaptivityAdjuster();
  return null;
 },
 CalculateAdaptivity: function(forceCalculate) {
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper)
   adaptivityHelper.CalculateAdaptivity(forceCalculate);
 },
 ResetAdaptivityOnCallback: function(){
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper)
   adaptivityHelper.ResetAdaptivityOnCallback();
 },
 RestoreAdaptivityState: function() {
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper)
   adaptivityHelper.RestoreAdaptivityState();
 },
 ToggleAdaptiveDetails: function(visibleIndex) {
  var adaptivityHelper = this.GetAdaptivityHelper();
  if(adaptivityHelper) {
   adaptivityHelper.ToggleAdaptiveDetails(visibleIndex, false, true);
   this.InvalidateLayout();
  }
 },
 UA_ShowAdaptiveDetail: function(visibleIndex) {
  this.ToggleAdaptiveDetails(visibleIndex);
 },
 UA_HideAdaptiveDetail: function(visibleIndex) {
  this.ToggleAdaptiveDetails(visibleIndex);
 },
 UA_ApplyMultiColumnAutoFilter: function() {
  this.ApplyOnClickRowFilter();
 },
 UA_CustDialogApply: function() {
  var helper = this.GetCustDialogHelper();
  if(helper)
   helper.ApplyChanges();
 },
 UA_CustDialogClose: function() {
  var helper = this.GetCustDialogHelper();
  if(helper)
   helper.CancelChanges();
 },
 UA_PreviewChanges: function() {
  var helper = this.GetBatchEditHelper();
  if(helper)
   helper.ShowChanges();
 },
 UA_HidePreview: function() {
  var helper = this.GetBatchEditHelper();
  if(helper)
   helper.HideChanges();
 },
 IsLastDataRow: function(visibleIndex) {
  return visibleIndex == this.visibleStartIndex + this.pageRowCount - 1 && (this.IsLastPage() || this.pageIndex < 0);
 },
 UpdateFirstAndLastVisibleRowMarkers: function() {
  if(this.HasBandedDataRows())
   return;
  if(!this.GetHeaderRow(0))
   this.UpdateExtemeVisibleRowMarker(true);
  this.UpdateExtemeVisibleRowMarker(false);
 },
 UpdateExtemeVisibleRowMarker: function(isFirstVisibleRow) {
  var tBody = ASPx.GetNodeByTagName(this.GetMainTable(), "TBODY", 0);
  var markerClassName = isFirstVisibleRow ? GridViewConsts.FirstVisibleRowClassName : GridViewConsts.LastVisibleRowClassName;
  var prevMarkedRows = ASPx.GetChildNodesByClassName(tBody, markerClassName);
  for(var i = 0; i < prevMarkedRows.length; i++) {
   ASPx.RemoveClassNameFromElement(prevMarkedRows[i], markerClassName);
  }
  var exteremeRow = this.FindExtemeVisibleRow(isFirstVisibleRow);
  if(exteremeRow) {
   ASPx.AddClassNameToElement(exteremeRow, markerClassName);
   if(!isFirstVisibleRow && this.GetLayoutHelper().HasCellMerging())
    this.MarkPageBottomVisibleCells(exteremeRow);
  }
 },
 MarkPageBottomVisibleCells: function(row) {
  var helper = this.GetLayoutHelper();
  var visibleIndex = this.getItemIndex(row.id);
  if(visibleIndex === -1)
   return;
  var headerLayout = helper.GetHeaderLayout()[helper.GetLayoutHeight(true) - 1];
  var headerColumnIndices = headerLayout.map(function(item) { return item.columnIndex; });
  for(var i = 0; i < headerColumnIndices.length; i++) {
   var columnIndex = headerColumnIndices[i];
   if(helper.IsHiddenMergedCell(visibleIndex, columnIndex))
    ASPx.AddClassNameToElement(this.GetDataCell(visibleIndex, columnIndex), GridViewConsts.PageBottomVisibleCellsMarkerClassName);
  }
 },
 FindExtemeVisibleRow: function(isFirstVisibleRow) {
  var rows = this.GetMainTable().rows;
  var rowCount = rows.length;
  for(var i = 0; i < rowCount; i++) {
   var row = isFirstVisibleRow ? rows[i] : rows[rowCount - 1 - i];
   if(this.IsVisibleRow(row))
    return row;
  }
  return this.GetEmptyDataItem();
 },
 IsVisibleRow: function(row) {
  var isDataRow = this.GetItemVisibleIndexRegExp(false).test(row.id);
  var isEditingRow = row.id && row.id.indexOf(this.EditingRowID) > -1;
  return ASPx.ElementContainsCssClass(row, this.EmptyPagerRowCssClass) || ((isDataRow || isEditingRow) && ASPx.GetElementDisplay(row));
 },
 OnGeneralCallback: function(result) {
  GetGridViewAdjuster().SaveDocumentScrollPosition(true);
  ASPxClientGridBase.prototype.OnGeneralCallback.call(this, result);
  if(this.hasDetailRows) {
   GetGridViewAdjuster().SetMasterGridForAdjust(this);
   if(this.HasAdaptivityAdjuster())
    this.GetAdaptivityAdjuster().SetNeedCollapseMasterGrid(this);
  }
 },
 OnCallbackFinalized: function() {
  this.ResetAdaptivityOnCallback();
  ASPxClientGridBase.prototype.OnCallbackFinalized.call(this);
  this.AdjustPagerControls();
  if(this.HasAdaptivityAdjuster())
   this.GetAdaptivityAdjuster().CalculateMasterDetailGridsAdaptivity(this);
  GetGridViewAdjuster().ResetDocumentScrollPosition();
 },
 SetWidth: function(width) {
  if(this.IsControlCollapsed())
   this.ExpandControl();
  var mainElemnt = this.GetMainElement();
  if(!ASPx.IsExistsElement(mainElemnt) || mainElemnt.offsetWidth === width) return;
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.OnSetWidth(width);
  this.ResetControlAdjustment();
  ASPxClientControl.prototype.SetWidth.call(this, width);
 },
 NeedCollapseControlCore: function() {
  return this.IsResponsiveAdaptivityMode() || ASPxClientGridBase.prototype.NeedCollapseControlCore.call(this);
 },
 SortBy: function(column, sortOrder, reset, sortIndex){
    ASPxClientGridBase.prototype.SortBy.call(this, column, sortOrder, reset, sortIndex);
 },
 MoveColumn: function(column, columnMoveTo, moveBefore, moveToGroup, moveFromGroup){
  ASPxClientGridBase.prototype.MoveColumn.call(this, column, columnMoveTo, moveBefore, moveToGroup, moveFromGroup);
 },
 MoveColumnCore: function(sourceIndex, targetIndex, direction, moveToGroup, moveFromGroup) {
  var helper = this.GetColumnMovingHelper();
  var requireCallback = !helper || !helper.MoveColumn(sourceIndex, targetIndex, direction, moveToGroup, moveFromGroup);
  this.Invalidate();
  if(requireCallback)
   ASPxClientGridBase.prototype.MoveColumnCore.call(this, sourceIndex, targetIndex, direction, moveToGroup, moveFromGroup);
  else {
   var adaptivityHelper = this.GetAdaptivityHelper();
   if(adaptivityHelper) {
    adaptivityHelper.ResetAdaptivity();
    this.RemoveAdaptiveHeaders();
    adaptivityHelper.CalculateAdaptivity(true);
   }
   var fixedHelper = this.GetFixedColumnsHelper();
   if(fixedHelper)
    fixedHelper.OnColumnClientMove();
   this.SaveClientColumnStateToCookies();
   this.stateObject.columnMoveState = helper.GetColumnMoveState();
  }
 },
 GetColumnLayout: function() {
  var helper = this.GetColumnMovingHelper();
  return helper ? helper.GetColumnLayout() : null;
 },
 SetColumnLayout: function(layout) {
  var helper = this.GetColumnMovingHelper();
  if(helper)
   helper.SetColumnLayout(layout);
 },
 SaveClientColumnStateToCookies: function() {
  if(!this.cookieName) return;
  var cookieValue = ASPx.Cookie.GetCookie(this.cookieName);
  if(!cookieValue) return;
  var prevClientStateIndex = cookieValue.indexOf("|clientvis");
  if(prevClientStateIndex > -1)
   cookieValue = cookieValue.substr(0, prevClientStateIndex);
  var columnHelper = this.GetColumnHelper();
  var visibleState = columnHelper.SerializeColumnVisibleState();
  var hierarchyState = columnHelper.SerializeColumnHierarchyState();
  cookieValue += "|" + hierarchyState + "|" + visibleState;
  ASPx.Cookie.SetCookie(this.cookieName, cookieValue);
 },
 GroupBy: function(column, groupIndex, sortOrder){
  ASPxClientGridBase.prototype.GroupBy.call(this, column, groupIndex, sortOrder);
 },
 UnGroup: function(column){
  this.Ungroup(column);
 },
 Ungroup: function(column){
  ASPxClientGridBase.prototype.Ungroup.call(this, column);
 },
 ExpandAll: function(){
  ASPxClientGridBase.prototype.ExpandAll.call(this);
 },
 CollapseAll: function(){
  ASPxClientGridBase.prototype.CollapseAll.call(this);
 },
 ExpandAllDetailRows: function(){
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ShowAllDetail]);
 },
 CollapseAllDetailRows: function(){
  this.gridCallBack([ASPxClientGridViewCallbackCommand.HideAllDetail]);
 },
 ExpandRow: function(visibleIndex, recursive){
  if(this.RaiseRowExpanding(visibleIndex)) return;
  recursive = !!recursive;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ExpandRow, visibleIndex, recursive]);
 },
 CollapseRow: function(visibleIndex, recursive){
  if(this.RaiseRowCollapsing(visibleIndex)) return;
  recursive = !!recursive;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.CollapseRow, visibleIndex, recursive]);
 },
 MakeRowVisible: function(visibleIndex) {
  if(!this.HasVertScroll()) return;
  var row = this.GetItem(visibleIndex);
  if(row == null && visibleIndex >= this.visibleStartIndex && visibleIndex < this.visibleStartIndex + this.pageRowCount) 
   row = this.GetEditingRow();
  if(row == null) return;
  this.GetScrollHelper().MakeRowVisible(row);
 },
 ExpandDetailRow: function(visibleIndex){
  var key = this.GetRowKey(visibleIndex);
  if(key == null) return;
  if(this.RaiseDetailRowExpanding(visibleIndex)) return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ShowDetailRow, key]);
 },
 CollapseDetailRow: function(visibleIndex){
  var key = this.GetRowKey(visibleIndex);
  if(key == null) return;
  if(this.RaiseDetailRowCollapsing(visibleIndex)) return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.HideDetailRow, key]);
 },
 GetRowKey: function(visibleIndex) {
  return this.GetItemKey(visibleIndex);
 },
 StartEditRow: function(visibleIndex) {
    this.StartEditItem(visibleIndex);
 },
 StartEditRowByKey: function(key) {
  this.StartEditItemByKey(key);
 },
 IsNewRowEditing: function() {
  return this.IsNewItemEditing();
 },
 AddNewRow: function(){
    this.AddNewItem();
 },
 DeleteRow: function(visibleIndex){
  this.DeleteItem(visibleIndex);
 },
 DeleteRowByKey: function(key) {
  this.DeleteItemByKey(key);
 },
 GetFocusedRowIndex: function() {
  return this._getFocusedItemIndex();
 },
 SetFocusedRowIndex: function(visibleIndex) {
  return this._setFocusedItemIndex(visibleIndex);
 },
 SelectRows: function(visibleIndices, selected){
  this.SelectItemsCore(visibleIndices, selected, false);
 },
 SelectRowsByKey: function(keys, selected){
  this.SelectItemsByKey(keys, selected);
 },
 UnselectRowsByKey: function(keys){
  this.SelectRowsByKey(keys, false);
 },
 UnselectRows: function(visibleIndices){
  this.SelectRows(visibleIndices, false);
 },
 UnselectFilteredRows: function() {
  this.UnselectFilteredItemsCore();
 },
 SelectRowOnPage: function(visibleIndex, selected){
  if(!ASPx.IsExists(selected)) selected = true;
  this.SelectItem(visibleIndex, selected);
 },
 UnselectRowOnPage: function(visibleIndex){
  this.SelectRowOnPage(visibleIndex, false);
 },
 SelectAllRowsOnPage: function(selected){
  this.SelectAllItemsOnPage(selected);
 },
 UnselectAllRowsOnPage: function(){
  this.UnselectAllItemsOnPage();
 },
 GetSelectedRowCount: function() {
  return this._getSelectedRowCount();
 },
 IsRowSelectedOnPage: function(visibleIndex) {
  return this._isRowSelected(visibleIndex);
 },
 IsGroupRow: function(visibleIndex) {
  return this.GetGroupRow(visibleIndex) != null;
 },
 IsDataRow: function(visibleIndex) {
  return this.GetDataRow(visibleIndex) != null || this.HasBandedDataRows() && this.GetBandedDataRows(visibleIndex).length > 0;
 },
 IsGroupRowExpanded: function(visibleIndex) { 
  return this.GetExpandedGroupRow(visibleIndex) != null;
 },
 GetVertScrollPos: function() {
  return this.GetVerticalScrollPosition();
 },
 GetVerticalScrollPosition: function() {
  if(this.IsVirtualScrolling())
   return 0;
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   return scrollHelper.GetVertScrollPosition();
  return 0;
 },
 GetHorzScrollPos: function() {
  return this.GetHorizontalScrollPosition();
 },
 GetHorizontalScrollPosition: function() {
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   return scrollHelper.GetHorzScrollPosition();
  return 0;
 },
 SetVertScrollPos: function(value) {
  this.SetVerticalScrollPosition(value);
 },
 SetVerticalScrollPosition: function(value) {
  if(this.IsVirtualScrolling())
   return;
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.SetVertScrollPosition(value);
 },
 SetHorzScrollPos: function(value) {
  this.SetHorizontalScrollPosition(value);
 },
 SetHorizontalScrollPosition: function(value) {
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.SetHorzScrollPosition(value);
 },
 SetFixedColumnScrollableRows: function(scrollableRowSettings) {
  var helper = this.GetFixedColumnsHelper();
  if(helper)
   helper.SetFixedColumnScrollableRows(scrollableRowSettings);
 },
 ExportTo: function(format) {
  ASPxClientGridBase.prototype.ExportTo.call(this, format);
 },
 RaiseItemClick: function(visibleIndex, htmlEvent) {
  if(!this.RowClick.IsEmpty()){
   var args = new ASPxClientGridViewRowClickEventArgs(visibleIndex, htmlEvent);
   this.RowClick.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseItemDblClick: function(visibleIndex, htmlEvent) {
  if(!this.RowDblClick.IsEmpty()){
   ASPx.Selection.Clear(); 
   var args = new ASPxClientGridViewRowClickEventArgs(visibleIndex, htmlEvent);
   this.RowDblClick.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseContextMenu: function(objectType, index, htmlEvent, menu, showBrowserMenu) {
  var args = new ASPxClientGridViewContextMenuEventArgs(objectType, index, htmlEvent, menu, showBrowserMenu);
  if(!this.ContextMenu.IsEmpty())
   this.ContextMenu.FireEvent(this, args);
  return !!args.showBrowserMenu;
 },
 RaiseFocusedItemChanged: function(isChangedOnServer) {
  if(!this.FocusedRowChanged.IsEmpty()){
   var args = new ASPxClientGridViewFocusEventArgs(isChangedOnServer);
   this.FocusedRowChanged.FireEvent(this, args);
   if(args.processOnServer)
    this.gridCallBack([ASPxClientGridViewCallbackCommand.FocusedRow]);
  }
  return false; 
 },
 RaiseItemFocusing: function(visibleIndex, htmlEvent) { 
  if(!this.RowFocusing.IsEmpty()){
   var args = new ASPxClientGridViewRowFocusingEventArgs(visibleIndex, htmlEvent);
   this.RowFocusing.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseColumnStartDragging: function(column) {
  if(!this.ColumnStartDragging.IsEmpty()){
   var args = new ASPxClientGridViewColumnCancelEventArgs(column);
   this.ColumnStartDragging.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseColumnResizing: function(column) {
  if(!this.ColumnResizing.IsEmpty()){
   var args = new ASPxClientGridViewColumnCancelEventArgs(column);
   this.ColumnResizing.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseColumnResized: function(column) {
  if(!this.ColumnResized.IsEmpty()){
   var args = new ASPxClientGridViewColumnProcessingModeEventArgs(column);
   this.ColumnResized.FireEvent(this, args);
   if(args.processOnServer)
    this.Refresh();
  }
 },
 RaiseRowExpanding: function(visibleIndex) {
  if(!this.RowExpanding.IsEmpty()){
   var args = new ASPxClientGridViewRowCancelEventArgs(visibleIndex);
   this.RowExpanding.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseRowCollapsing: function(visibleIndex) {
  if(!this.RowCollapsing.IsEmpty()){
   var args = new ASPxClientGridViewRowCancelEventArgs(visibleIndex);
   this.RowCollapsing.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseDetailRowExpanding: function(visibleIndex) {
  if(!this.DetailRowExpanding.IsEmpty()){
   var args = new ASPxClientGridViewRowCancelEventArgs(visibleIndex);
   this.DetailRowExpanding.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseDetailRowCollapsing: function(visibleIndex) {
  if(!this.DetailRowCollapsing.IsEmpty()){
   var args = new ASPxClientGridViewRowCancelEventArgs(visibleIndex);
   this.DetailRowCollapsing.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseBatchEditConfirmShowing: function(requestTriggerID) {
  if(!this.BatchEditConfirmShowing.IsEmpty()) {
   var args = new ASPxClientGridViewBatchEditConfirmShowingEventArgs(requestTriggerID);
   this.BatchEditConfirmShowing.FireEvent(this, args);
   return args.cancel;
  }
  return false;
 },
 RaiseBatchEditStartEditing: function(visibleIndex, column, rowValues) {
  var args = new ASPxClientGridViewBatchEditStartEditingEventArgs(visibleIndex, column, rowValues, this.ConvertVisibleIndexToKey(visibleIndex));
  if(!this.BatchEditStartEditing.IsEmpty())
   this.BatchEditStartEditing.FireEvent(this, args);
  return args;
 },
 RaiseBatchEditEndEditing: function(visibleIndex, rowValues) {
  var args = new ASPxClientGridViewBatchEditEndEditingEventArgs(visibleIndex, rowValues, this.ConvertVisibleIndexToKey(visibleIndex));
  if(!this.BatchEditEndEditing.IsEmpty())
   this.BatchEditEndEditing.FireEvent(this, args);
  return args;
 },
 RaiseBatchEditItemValidating: function(visibleIndex, validationInfo) {
  var args = new ASPxClientGridViewBatchEditRowValidatingEventArgs(visibleIndex, validationInfo, this.ConvertVisibleIndexToKey(visibleIndex));
  if(!this.BatchEditRowValidating.IsEmpty())
   this.BatchEditRowValidating.FireEvent(this, args);
  return args.validationInfo;
 },
 RaiseBatchEditTemplateCellFocused: function(columnIndex) {
  var column = this._getColumn(columnIndex);
  if(!column) return false;
  var args = new ASPxClientGridViewBatchEditTemplateCellFocusedEventArgs(column);
  if(!this.BatchEditTemplateCellFocused.IsEmpty())
   this.BatchEditTemplateCellFocused.FireEvent(this, args);
  return args.handled;
 },
 RaiseBatchEditChangesSaving: function(valuesInfo) { 
  if(!this.BatchEditChangesSaving.IsEmpty()){
   var args = new ASPxClientGridViewBatchEditChangesSavingEventArgs(valuesInfo.insertedValues, valuesInfo.deletedValues, valuesInfo.updatedValues);
   this.BatchEditChangesSaving.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseBatchEditChangesCanceling: function(valuesInfo) { 
  if(!this.BatchEditChangesCanceling.IsEmpty()){
   var args = new ASPxClientGridViewBatchEditChangesCancelingEventArgs(valuesInfo.insertedValues, valuesInfo.deletedValues, valuesInfo.updatedValues);
   this.BatchEditChangesCanceling.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseBatchEditItemInserting: function(visibleIndex) { 
  if(!this.BatchEditRowInserting.IsEmpty()){
   var args = new ASPxClientGridViewBatchEditRowInsertingEventArgs(visibleIndex);
   this.BatchEditRowInserting.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseBatchEditItemDeleting: function(visibleIndex, itemValues) { 
  if(!this.BatchEditRowDeleting.IsEmpty()){
   var args = new ASPxClientGridViewBatchEditRowDeletingEventArgs(visibleIndex, itemValues, this.ConvertVisibleIndexToKey(visibleIndex));
   this.BatchEditRowDeleting.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseBatchEditItemRecovering: function(visibleIndex, itemValues) { 
  if(!this.BatchEditRowRecovering.IsEmpty()){
   var args = new ASPxClientGridViewBatchEditRowRecoveringEventArgs(visibleIndex, itemValues, this.ConvertVisibleIndexToKey(visibleIndex));
   this.BatchEditRowRecovering.FireEvent(this, args);
   return args.cancel;
  }
  return false;
 },
 RaiseBatchEditChangesPreviewShowing: function() { 
  if(!this.BatchEditChangesPreviewShowing.IsEmpty()){
   var args = new ASPxClientCancelEventArgs();
   this.BatchEditChangesPreviewShowing.FireEvent(this, args);
   return args.cancel;
  }
  return false;
 },
 RaiseBatchEditChangesPreviewShown: function() { 
  if(!this.BatchEditChangesPreviewShown.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.BatchEditChangesPreviewShown.FireEvent(this, args);
  }
 },
 RaiseContextMenuItemClick: function(e, itemInfo) {
  if(this.ContextMenuItemClick.IsEmpty())
   return false;
  var args = new ASPxClientGridViewContextMenuItemClickEventArgs(e.item, itemInfo.objectType, itemInfo.index);
  this.ContextMenuItemClick.FireEvent(this, args);
  if(!args.handled && args.processOnServer) {
   this.GetContextMenuHelper().ProcessCustomContextMenuItemClick(args.usePostBack);
   return true;
  }
  return args.handled;
 },
 RaiseColumnMoving: function(targets) {
  if(this.ColumnMoving.IsEmpty()) return;
  var srcColumn = this.getColumnObject(targets.obj.id);
  var destColumn = this.getColumnObject(targets.targetElement.id);
  var isLeft = targets.isLeftPartOfElement();
  var isGroupPanel = targets.targetElement == targets.control.GetGroupPanel();
  var args = new ASPxClientGridViewColumnMovingEventArgs(srcColumn, destColumn, isLeft, isGroupPanel);
  this.ColumnMoving.FireEvent(this, args);
  if(!args.allow)
   targets.targetElement = null;
 },
 CreateCommandCustomButtonEventArgs: function(index, id){
  return new ASPxClientGridViewCustomButtonEventArgs(index, id);
 },
 CreateSelectionEventArgs: function(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer){
  return new ASPxClientGridViewSelectionEventArgs(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer);
 },
 CreateColumnCancelEventArgs: function(column){
  return new ASPxClientGridViewColumnCancelEventArgs(column);
 },
 CreateColumnMovingEventArgs: function(sourceColumn, destinationColumn, isDropBefore, isGroupPanel){
  return new ASPxClientGridViewColumnMovingEventArgs(sourceColumn, destinationColumn, isDropBefore, isGroupPanel);
 },
 CreateCellInfo: function(visibleIndex, column, key) { return new ASPxClientGridViewCellInfo(visibleIndex, column, key); },
 CreateFocusedCellChangingArgs: function(cellInfo) { return new ASPxClientGridViewFocusedCellChangingEventArgs(cellInfo); },
 GetRowValues: function(visibleIndex, fieldNames, onCallBack) {
  this.GetItemValues(visibleIndex, fieldNames, onCallBack);
 },
 GetPageRowValues: function(fieldNames, onCallBack) {
  this.GetPageItemValues(fieldNames, onCallBack);
 },
 GetVisibleRowsOnPage: function() {
  return this.GetVisibleItemsOnPage();
 }, 
 GetVisibleRowsIndicesForAdaptivity: function() {
  var batchEditHelper = this.GetBatchEditHelper();
  var currentPageIndices = this.GetCurrentPageIndices();
  if(batchEditHelper) {
   if(batchEditHelper.IsChangesViewVisible())
    return batchEditHelper.GetChangedRecordKeys().map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this));
   var indices = this.GetDataItemVisibleIndices(batchEditHelper.GetHighlightDeletedItems());
   var groupRowIndices = currentPageIndices.filter(function(index){ this.IsGroupRow(index); }.bind(this));
   return indices.concat(groupRowIndices);
  }
  if(this.IsInlineEditMode() && this.IsNewRowEditing()) 
   currentPageIndices.push(this.NewRowVisibleIndex);
  return currentPageIndices;
 },
 GetClientChangedVisibleIndices: function(includeDeleted, fromAPI) {
  var helper = this.GetBatchEditHelper();
  if(!helper) 
   return [ ];
  return helper.GetChangedRecordKeys().map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this));
 },
 GetRowIndicesVisibleInViewPort: function(includePartiallyVisible) {
  var mainTable = this.GetMainTable();
  var treeLine = ASPx.GetElementTreeLine(mainTable).filter(function(element) {
   var style = ASPx.GetCurrentStyle(element);
   return style.overflow !== "visible" || style.overflowY !== "visible";
  });
  treeLine.push(mainTable);
  treeLine.push(document.body);
  var treeLineDimensions = treeLine.map(function(element) { 
   var y = ASPx.GetAbsoluteY(element);
   var height = element.tagName === "BODY" ? ASPx.GetDocumentClientHeight() : element.offsetHeight;
   return { element: element, top: y, bottom: y + height - 1 };
  });
  var mainTableViewPortTop = ASPx.Data.Max(treeLineDimensions, function(info) { return info.top; });
  var mainTableViewPortBottom = ASPx.Data.Min(treeLineDimensions, function(info) { return info.bottom; });
  var dataRowVisibleIndices = this.GetLayoutHelper().GetDataItemVisibleIndices();
  var groupRowVisibleIndices = ASPx.Data.Range(this.GetVisibleRowsOnPage(), this.GetTopVisibleIndex()).filter(function(i) { return this.IsGroupRow(i); }.bind(this));
  var dataRows = dataRowVisibleIndices.map(function(i) {   return { visibleIndex: i, row: this.GetDataRow(i) }; }.bind(this));
  var groupRows = groupRowVisibleIndices.map(function(i) { return { visibleIndex: i, row: this.GetGroupRow(i) }; }.bind(this));
  var result = dataRows.concat(groupRows).filter(function(rowInfo) {
   var rowTop = ASPx.GetAbsoluteY(rowInfo.row);
   var rowBottom = rowTop + rowInfo.row.offsetHeight - 1;
   if(includePartiallyVisible)
    return rowTop <= mainTableViewPortBottom && rowBottom >= mainTableViewPortTop;
   return rowTop >= mainTableViewPortTop && rowBottom <= mainTableViewPortBottom;
  }).map(function(rowInfo) { return rowInfo.visibleIndex; });
  ASPx.Data.ArrayIntegerSort(result);
  return result;
 },
 ApplyOnClickRowFilter: function() {
  this.GetFilterHelper().ApplyMultiColumnAutoFilter();
 }
});
ASPxClientGridView.Cast = ASPxClientControl.Cast;
var ASPxClientGridViewColumn = ASPx.CreateClass(ASPxClientGridColumnBase, {
 constructor: function(prop){
  this.constructor.prototype.constructor.call(this, prop);
  this.visibleIndex =    ASPx.IsExists(prop[8])  ? prop[8]  : -1;
  this.groupIndex =      ASPx.IsExists(prop[9])  ? prop[9]  : -1;
  this.columnType =      ASPx.IsExists(prop[10]) ? prop[10] : 0;
  this.filterRowTypeKind =  ASPx.IsExists(prop[11]) ? prop[11] : "";
  this.isFixed =      ASPx.IsExists(prop[12]) ?  !!prop[12] : false;
  this.allowGroup =      ASPx.IsExists(prop[13]) ?  !!prop[13] : true;
  this.allowDrag =    ASPx.IsExists(prop[14]) ?  !!prop[14] : true;
  this.parentIndex =     ASPx.IsExists(prop[15]) ? prop[15] : -1;
  this.inCustWindow =    ASPx.IsExists(prop[16]) ?  !!prop[16] : false;
  this.minWidth =     ASPx.IsExists(prop[17]) ? prop[17] : 0;
  this.maxWidth =     ASPx.IsExists(prop[18]) ? prop[18] : 0;
  this.rowSpan =      ASPx.IsExists(prop[19]) ? prop[19] : 1;
  this.showFilterMenuLikeItem =   ASPx.IsExists(prop[20]) ?  !!prop[20] : false;
  this.collectionIndex  =   ASPx.IsExists(prop[21]) ? prop[21] : -1;
  this.showInCustomizationForm =  ASPx.IsExists(prop[22]) ?  !!prop[22] : true;
  this.isCommandColumn = this.columnType === 1;
  this.isBand = this.columnType === 2;
 }
});
var ASPxClientGridViewColumnCancelEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(column){
  this.constructor.prototype.constructor.call(this);
  this.column = column;
 }
});
var ASPxClientGridViewColumnProcessingModeEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(column){
  this.constructor.prototype.constructor.call(this, false);
  this.column = column;
 }
});
var ASPxClientGridViewRowCancelEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(visibleIndex){
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
 }
});
var ASPxClientGridViewSelectionEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer){
  this.constructor.prototype.constructor.call(this, false);
  this.visibleIndex = visibleIndex;
  this.isSelected = isSelected;
  this.isAllRecordsOnPage = isAllRecordsOnPage;
  this.isChangedOnServer = !!isChangedOnServer;
 }
});
var ASPxClientGridViewFocusEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(isChangedOnServer){
  this.constructor.prototype.constructor.call(this, false);
  this.isChangedOnServer = !!isChangedOnServer;
 }
});
var ASPxClientGridViewRowFocusingEventArgs = ASPx.CreateClass(ASPxClientGridViewRowCancelEventArgs, {
 constructor: function(visibleIndex, htmlEvent){
  this.constructor.prototype.constructor.call(this, visibleIndex);
  this.htmlEvent = htmlEvent;
 }
});
var ASPxClientGridViewRowClickEventArgs = ASPx.CreateClass(ASPxClientGridViewRowCancelEventArgs, {
 constructor: function(visibleIndex, htmlEvent){
  this.constructor.prototype.constructor.call(this, visibleIndex);
  this.htmlEvent = htmlEvent;
 }
});
var ASPxClientGridViewContextMenuEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(objectType, index, htmlEvent, menu, showBrowserMenu) {
  this.constructor.prototype.constructor.call(this);
  this.objectType = objectType;
  this.index = index;
  this.htmlEvent = htmlEvent;
  this.menu = menu;
  this.showBrowserMenu = showBrowserMenu;
 }
});
var ASPxClientGridViewContextMenuItemClickEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(item, objectType, elementIndex, processOnServer){
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.item = item;
  this.objectType = objectType;
  this.elementIndex = elementIndex;
  this.usePostBack = false;
  this.handled = false;
 }
});
var ASPxClientGridViewCustomButtonEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(visibleIndex, buttonID) {
  this.constructor.prototype.constructor.call(this, false);
  this.visibleIndex = visibleIndex;
  this.buttonID = buttonID;
 } 
});
var ASPxClientGridViewColumnMovingEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(sourceColumn, destinationColumn, isDropBefore, isGroupPanel) {
  this.constructor.prototype.constructor.call(this);
  this.allow = true;
  this.sourceColumn = sourceColumn;
  this.destinationColumn = destinationColumn;
  this.isDropBefore = isDropBefore;
  this.isGroupPanel = isGroupPanel;
 }
});
var ASPxClientGridViewBatchEditConfirmShowingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditConfirmShowingEventArgs, {
 constructor: function(requestTriggerID) {
  this.constructor.prototype.constructor.call(this, requestTriggerID);
 }
});
var ASPxClientGridViewBatchEditStartEditingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditStartEditingEventArgs, {
 constructor: function(visibleIndex, focusedColumn, itemValues, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, focusedColumn, itemValues);
  this.rowValues = this.itemValues;
  this.key = key;
 }
});
var ASPxClientGridViewBatchEditEndEditingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditEndEditingEventArgs, {
 constructor: function(visibleIndex, itemValues, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, itemValues);
  this.rowValues = this.itemValues;
  this.key = key;
 }
});
var ASPxClientGridViewBatchEditRowValidatingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditItemValidatingEventArgs, {
 constructor: function(visibleIndex, validationInfo, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, validationInfo);
  this.key = key;
 }
});
var ASPxClientGridViewBatchEditTemplateCellFocusedEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditTemplateCellFocusedEventArgs, {
 constructor: function(column) {
  this.constructor.prototype.constructor.call(this, column);
 }
});
var ASPxClientGridViewBatchEditChangesSavingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditClientChangesEventArgs, {
 constructor: function(insertedValues, deletedValues, updatedValues) {
  this.constructor.prototype.constructor.call(this, insertedValues, deletedValues, updatedValues);
 }
});
var ASPxClientGridViewBatchEditChangesCancelingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditClientChangesEventArgs, {
 constructor: function(insertedValues, deletedValues, updatedValues) {
  this.constructor.prototype.constructor.call(this, insertedValues, deletedValues, updatedValues);
 }
});
var ASPxClientGridViewBatchEditRowInsertingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditItemInsertingEventArgs, {
 constructor: function(visibleIndex) {
  this.constructor.prototype.constructor.call(this, visibleIndex);
 }
});
var ASPxClientGridViewBatchEditRowDeletingEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditItemDeletingEventArgs, {
 constructor: function(visibleIndex, itemValues, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, itemValues, key);  
  this.rowValues = this.itemValues;  
  this.key = key;
 }
});
var ASPxClientGridViewBatchEditRowRecoveringEventArgs = ASPx.CreateClass(ASPxClientGridBatchEditItemDeletingEventArgs, {
 constructor: function(visibleIndex, itemValues, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, itemValues, key);  
  this.rowValues = this.itemValues; 
  this.key = key;
 }
});
var ASPxClientGridViewFocusedCellChangingEventArgs = ASPx.CreateClass(ASPxClientGridFocusedCellChangingEventArgs, {
 constructor: function(cellInfo) {
  this.constructor.prototype.constructor.call(this, cellInfo);
 }
});
var ASPxClientGridViewCellInfo = ASPx.CreateClass(ASPxClientGridCellInfo, {
 constructor: function(visibleIndex, column, key) {
  this.constructor.prototype.constructor.call(this, visibleIndex, column);
  this.rowVisibleIndex = this.itemVisibleIndex;
  this.key = key;
 }
});
ASPx.GVContextMenu = function(name, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  var showDefaultMenu = gv.GetContextMenuHelper().OnContextMenuClick(e);
  if(!showDefaultMenu)
   ASPx.Evt.PreventEventAndBubble(e);
  return showDefaultMenu;
  }
 return true;
};
ASPx.GVContextMenuItemClick = function(name, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetContextMenuHelper().OnContextMenuItemClick(e);
};
ASPx.GVExpandRow = function(name, visibleIndex, event) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  if(gv.useEndlessPaging && event)
   visibleIndex = gv.FindParentRowVisibleIndex(ASPx.Evt.GetEventSource(event), true);
  gv.ExpandRow(visibleIndex);
 }
};
ASPx.GVCollapseRow = function(name, visibleIndex, event) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  if(gv.useEndlessPaging && event)
   visibleIndex = gv.FindParentRowVisibleIndex(ASPx.Evt.GetEventSource(event), true);
  gv.CollapseRow(visibleIndex);
 }
};
ASPx.GVShowDetailRow = function(name, visibleIndex, event) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  if(gv.useEndlessPaging && event)
   visibleIndex = gv.FindParentRowVisibleIndex(ASPx.Evt.GetEventSource(event), true);
  gv.ExpandDetailRow(visibleIndex);
 }
};
ASPx.GVHideDetailRow = function(name, visibleIndex, event) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  if(gv.useEndlessPaging && event)
   visibleIndex = gv.FindParentRowVisibleIndex(ASPx.Evt.GetEventSource(event), true);
  gv.CollapseDetailRow(visibleIndex);
 }
};
ASPx.Evt.AttachEventToElement(window, "scroll", function(evt) {
 ASPx.GetControlCollection().ForEachControl(function(control){
  if(control instanceof ASPxClientGridView && ASPx.IsExists(control.GetMainElement()))
   control.OnScroll(evt);
 });
});
var GridViewCallbackHelper = ASPx.CreateClass(ASPx.GridCallbackHelper, {
 constructor: function(grid) {
  this.constructor.prototype.constructor.call(this, grid);
 },
 GetResizingState: function() { return this.grid.stateObject.resizingState; },
 GetContextMenuState: function() { return this.grid.GetContextMenuHelper().GetCallbackState(); },
 GetGridCallbackState: function() {
  var state = ASPx.GridCallbackHelper.prototype.GetGridCallbackState.call(this);
  return state.concat([
   [ "CR", this.GetResizingState() ],
   [ "CM", this.GetContextMenuState() ]
  ]);
 }
});
var GridViewKbdHelper = ASPx.CreateClass(ASPx.KbdHelper, {
  CanFocus: function(e) {
  var grid = this.control;
  if(grid.IsDetailGridFocused(e))
   return false;
  var batchEditHelper = grid.GetBatchEditHelper();
  if(batchEditHelper && batchEditHelper.CanStartEditOnTableClick(grid.getItemByHtmlEvent(e), e))
   return false;
  var filterControlPopup = grid.GetFilterControlPopup();
  if(filterControlPopup && filterControlPopup.IsVisible())
   return false;
  return ASPx.KbdHelper.prototype.CanFocus(e);
 },
 HandleKeyDown: function(e) {
  this.moveIterationCount = 0;
  var grid = this.control;
  var index = grid.GetFocusedRowIndex();
  var busy = grid.keyboardLock;
  var key = ASPx.Evt.GetKeyCode(e);
  if(grid.rtl) {
   if(key == ASPx.Key.Left)
    key = ASPx.Key.Right;
   else if(key == ASPx.Key.Right)
    key = ASPx.Key.Left;
  }
  switch(key) {
   case ASPx.Key.Down:
    if(!busy) 
     this.TryMoveFocusDown(index, e.shiftKey, e);
    return true;
   case ASPx.Key.Up:
    if(!busy) 
     this.TryMoveFocusUp(index, e.shiftKey, e);
    return true;
   case ASPx.Key.Right:
    if(!busy) {
     if(!this.TryExpand(index))
      this.TryMoveFocusDown(index, e.shiftKey, e);
    }
    return true;
   case ASPx.Key.Left:
    if(!busy) {
     if(!this.TryCollapse(index))
      this.TryMoveFocusUp(index, e.shiftKey, e);
    }
    return true;
   case ASPx.Key.PageDown:
    if(e.shiftKey) {
     if(!busy && grid.pageIndex < grid.pageCount - 1)
      grid.NextPage();
     return true; 
    }
    break;
   case ASPx.Key.PageUp:
    if(e.shiftKey) {
     if(!busy && grid.pageIndex > 0)
      grid.PrevPage();
     return true; 
    }
    break;     
  }
  return false;
 },
 HandleKeyPress: function(e) {
  var grid = this.control;
  var index = grid.GetFocusedRowIndex();
  var busy = grid.keyboardLock;
  switch(ASPx.Evt.GetKeyCode(e)) {
   case ASPx.Key.Space:
    if(!busy && this.IsRowSelectable(index))
     if(grid.IsRowSelectedOnPage(index)) {
      grid.UnselectRowOnPage(index);
     } else {
      grid.SelectRowOnPage(index);
     }
    return true;
    case 43:
    if(!busy)
     this.TryExpand(index);
    return true;
    case 45: 
    if(!busy)   
     this.TryCollapse(index);    
    return true;
  }
  return false;
 },
 EnsureFocusedRowVisible: function() {
  var grid = this.control;
  if(!grid.HasVertScroll()) return;
  var row = grid.GetItem(grid.GetFocusedRowIndex());
  grid.GetScrollHelper().MakeRowVisible(row, true);
 },
 HasDetailButton: function(expanded) {
  var grid = this.control;
  var row = grid.GetItem(grid.GetFocusedRowIndex());
  if(!row) return;
  var needle = expanded ? "ASPx.GVHideDetailRow" : "ASPx.GVShowDetailRow";
  return row.innerHTML.indexOf(needle) > -1;
 },
 IsRowSelectable: function(index) {
  if(this.control.allowSelectByItemClick)
   return true;
  var row = this.control.GetItem(index);
  if(row && row.innerHTML.indexOf("aspxGVSelectRow") > -1)
   return true;
  var check = this.control.GetDataRowSelBtn(index); 
  if(check && this.control.internalCheckBoxCollection && !!this.control.internalCheckBoxCollection.Get(check.id))
   return true;
  return false;
 },
 UpdateShiftSelection: function(start, end) {
  var grid = this.control;
  grid.UnselectAllRowsOnPage();
  if(grid.lastMultiSelectIndex > -1)   
   start = grid.lastMultiSelectIndex;
  else   
   grid.lastMultiSelectIndex = start;
  if(grid.allowSelectSingleRowOnly)
   start = end;
  for(var i = Math.min(start, end); i <= Math.max(start, end); i++)
   grid.SelectRowOnPage(i);
 },
 TryExpand: function(index) {
  var grid = this.control;
  if(grid.IsGroupRow(index) && !grid.IsGroupRowExpanded(index)) {
   grid.ExpandRow(index);
   return true;
  }
  if(this.HasDetailButton(false)) {
   grid.ExpandDetailRow(index);
   return true;
  }
  return false;
 },
 TryCollapse: function(index) {
  var grid = this.control;
  if(grid.IsGroupRow(index) && grid.IsGroupRowExpanded(index)) {
   grid.CollapseRow(index);
   return true;
  }
  if(this.HasDetailButton(true)) {
   grid.CollapseDetailRow(index);
   return true;
  }
  return false;
 },
 TryMoveFocusDown: function(index, select, htmlEvent) {
  this.moveIterationCount++;
  var grid = this.control;
  if(index < grid.visibleStartIndex + grid.pageRowCount - 1) {
   var focusedRowIndex = index >= 0 ? index + 1 : grid.visibleStartIndex;
   var focusChanged = grid.TryFocusItem(focusedRowIndex, htmlEvent);
   this.EnsureFocusedRowVisible();
   if(this.IsRowSelectable(index)) {
    if(select) {
     this.UpdateShiftSelection(index, index + 1);
    } else {
     grid.lastMultiSelectIndex = -1;
    }
   }
   if(grid.allowFocusedRow && !grid.InCallback() && !focusChanged && this.moveIterationCount < 100)
    this.TryMoveFocusDown(++index, select, htmlEvent);
  } else {
   if(grid.pageIndex < grid.pageCount - 1 && grid.pageIndex >= 0) {       
    grid.NextPage();
   }
  }  
 },
 TryMoveFocusUp: function(index, select, htmlEvent) {
  this.moveIterationCount++;
  var grid = this.control;
  if(index > grid.visibleStartIndex || index == -1) {
   var focusedRowIndex = index >= 0 ? index - 1 : grid.visibleStartIndex + grid.pageRowCount - 1;
   var focusChanged = grid.TryFocusItem(focusedRowIndex, htmlEvent);
   this.EnsureFocusedRowVisible();
   if(this.IsRowSelectable(index)) {
    if(select) {
     this.UpdateShiftSelection(index, index - 1);
    } else {
     grid.lastMultiSelectIndex = -1;
    }
   }
   if(grid.allowFocusedRow && !grid.InCallback() && !focusChanged && this.moveIterationCount < 100)
    this.TryMoveFocusUp(--index, select, htmlEvent);
  } else {
   if(grid.pageIndex > 0) {
    grid.PrevPage(true);
   }
  }
 }
});
var GridViewHeaderMatrix = ASPx.CreateClass(null, {
 constructor: function(grid) {
  this.grid = grid;
 },
 Invalidate: function() {
  this.matrix = null;
  this.inverseMatrix = null;
 },
 GetRowCount: function() {
  this.EnsureMatrix();
  return this.matrix.length;
 },
 IsLeftmostColumn: function(columnIndex) {
  this.EnsureMatrix();
  return this.inverseMatrix[columnIndex].left == 0;
 },
 IsRightmostColumn: function(columnIndex) {
  this.EnsureMatrix();  
  return this.inverseMatrix[columnIndex].right == this.matrix[0].length - 1;
 },
 IsLeaf: function(columnIndex) {
  this.EnsureMatrix();
  return this.inverseMatrix.hasOwnProperty(columnIndex) && this.inverseMatrix[columnIndex].bottom == this.matrix.length - 1;
 },
 GetLeaf: function(columnIndex, isLeft, isOuter) {
  this.EnsureMatrix();
  var rect = this.inverseMatrix[columnIndex];
  var row = this.matrix[this.matrix.length - 1];
  if(isLeft) {
   if(isOuter)
    return row[rect.left - 1];
   return row[rect.left];
  }
  if(isOuter)
   return row[rect.right + 1];
  return row[rect.right];
 },
 GetLeafIndex: function(columnIndex) {
  this.EnsureMatrix();
  return this.inverseMatrix[columnIndex].left;
 },
 GetLeafIndices: function() {
  return this.GetRowIndices(this.GetRowCount() - 1);
 },
 GetRowIndices: function(rowIndex) {
  this.EnsureMatrix();
  return this.matrix[rowIndex] || [];
 },
 GetRowSpan: function(columnIndex) {
  this.EnsureMatrix();
  var rect = this.inverseMatrix[columnIndex];
  return rect.bottom - rect.top + 1;
 },
 GetLeftNeighbor: function(columnIndex, skipHidden) {
  return this.GetNeighbor(columnIndex, true, skipHidden);
 },
 GetRightNeighbor: function(columnIndex, skipHidden) {
  return this.GetNeighbor(columnIndex, false, skipHidden);
 },
 GetNeighbor: function(columnIndex, isLeft, skipHidden) {
  this.EnsureMatrix();
  if(!skipHidden)
   return this.GetNeighborCore(columnIndex, isLeft);
  var boundLeafIndex = this.GetBoundLeaf(isLeft);
  while(columnIndex !== boundLeafIndex) {
   columnIndex = this.GetNeighborCore(columnIndex, isLeft);
   if(isNaN(columnIndex) || !this.GetColumn(columnIndex).adaptiveHidden)
    return columnIndex;
  }
 },
 GetNeighborCore: function(columnIndex, isLeft) {
  var rect = this.inverseMatrix[columnIndex];
  var cellIndex = isLeft ? rect.left - 1 : rect.right + 1;
  return this.matrix[rect.top][cellIndex];
 },
 GetBoundLeaf: function(isLeft) {
  var leafs = this.GetLeafIndices();
  var cellIndex = isLeft ? 0 : leafs.length - 1;
  return leafs[cellIndex];
 },
 GetColumnLevel: function(columnIndex) {
  this.EnsureMatrix();
  var rect = this.inverseMatrix[columnIndex];
  return rect ? rect.top : -1;
 },
 GetColumnHelper: function() { return this.grid.GetColumnHelper(); },
 GetColumn: function(columnIndex) { return this.grid.GetColumn(columnIndex); },
 EnsureMatrix: function() {
  if(!this.matrix)
   this.Fill();
 },
 Fill: function() {
  var columnHelper = this.GetColumnHelper();
  var headerLayout = columnHelper.GetHeaderLayout();
  var info = columnHelper.CreateLayoutMatrixInfo(headerLayout);
  this.matrix = info.matrix;
  this.inverseMatrix = info.inverseMatrix;
 }
});
var GridViewAdjuster = ASPx.CreateClass(null, {
 constructor: function() {
  this.masterGridForAdjust = null;
  this.documentScrollTop = GridViewConsts.UnspecifiedScrollPosition;
  this.lockDocumentScrollRestoring = false;
 },
 GetMasterGridForAdjust: function() {
  return this.masterGridForAdjust;
 },
 SetMasterGridForAdjust: function(grid) {
  this.masterGridForAdjust = grid;
 },
 SaveDocumentScrollPosition: function(lockRestoring) {
  if(this.documentScrollTop === GridViewConsts.UnspecifiedScrollPosition)
   this.documentScrollTop = ASPx.GetDocumentScrollTop();
  this.lockDocumentScrollRestoring = this.lockDocumentScrollRestoring || lockRestoring;
 },
 RestoreDocumentScrollPosition: function(forceRestoring) {
  if((!this.lockDocumentScrollRestoring || forceRestoring) && this.documentScrollTop !== GridViewConsts.UnspecifiedScrollPosition) {
   if(this.documentScrollTop !== ASPx.GetDocumentScrollTop())
    ASPx.SetDocumentScrollTop(this.documentScrollTop);
   this.documentScrollTop = GridViewConsts.UnspecifiedScrollPosition;
  }
  this.lockDocumentScrollRestoring = this.lockDocumentScrollRestoring && !forceRestoring;
 },
 ResetDocumentScrollPosition: function() {
  this.documentScrollTop = GridViewConsts.UnspecifiedScrollPosition;
  this.lockDocumentScrollRestoring = false;
 }
});
var gridViewAdjuster = new GridViewAdjuster();
function GetGridViewAdjuster() {
 return gridViewAdjuster;
}
var GridViewStyleHelper = ASPx.CreateClass(ASPx.GridStyleHelper, {
 BatchEditNewItemKey: "beni",
 FocusedGroupItemKey: "fgi",
 GetFocusedGroupItemStyle: function() { return this.GetStyleInfo(this.FocusedGroupItemKey); },
 GetBatchEditNewItemStyle: function() { return this.GetStyleInfo(this.BatchEditNewItemKey); },
 IsFocusedItemStyle: function(style) { 
  return  ASPx.GridStyleHelper.prototype.IsFocusedItemStyle.call(this, style) || this.IsFocusedGroupItemStyle(style);
 },
 IsFocusedGroupItemStyle: function(style) { return this.CheckStyleInfoByKey(style, this.FocusedGroupItemKey); }
});
var ASPxClientGridViewBatchEditApi = ASPx.CreateClass(ASPxClientGridBatchEditApi, {
 constructor: function(grid) {
  this.constructor.prototype.constructor.call(this, grid);
 },
 ValidateRows: function(validateOnlyModified, validateOnCurrentPageOnly) { return this.ValidateItems(validateOnlyModified, validateOnCurrentPageOnly); },
 ValidateRow: function(visibleIndex) { return this.ValidateItem(visibleIndex); },
 ValidateRowByKey: function(key) { return this.ValidateItemByKey(key); },
 GetRowVisibleIndices: function(includeDeleted) { return this.GetItemVisibleIndices(includeDeleted); },
 GetDeletedRowIndices: function() { return this.GetDeletedItemVisibleIndices(); },
 GetInsertedRowIndices: function() { return this.GetInsertedItemVisibleIndices(); },
 GetUpdatedRowIndices: function() { return this.GetUpdatedItemVisibleIndices(); },
 IsDeletedRow: function(visibleIndex) { return this.IsDeletedItem(visibleIndex); },
 IsDeletedRowByKey: function(key) { return this.IsDeletedItemByKey(key); },
 IsNewRow: function(visibleIndex) { return this.IsNewItem(visibleIndex); },
 AddNewRow: function() { this.AddNewItem(); },
 DeleteRow: function(visibleIndex) { this.DeleteItem(visibleIndex); },
 DeleteRowByKey: function(key) { this.DeleteItemByKey(key); },
 RecoverRow: function(visibleIndex) { this.RecoverItem(visibleIndex); },
 RecoverRowByKey: function(key) { this.RecoverItemByKey(key); },
 ShowChangesPreview: function () {
  var helper = this.GetHelper();
  if(helper)
   helper.ShowChanges();
 },
 HideChangesPreview: function () {
  var helper = this.GetHelper();
  if(helper)
   helper.HideChanges();
 },
 IsCurrentPageRow: function(key) { return this.IsCurrentPageRecord(key); },
});
var ASPxClientGridViewGlobalEventsListener = ASPx.CreateClass(ASPxClientComponent, {
 OnGlobalEndCallback: function(args) {
  ASPxClientControl.prototype.OnGlobalEndCallback.call(this, args);
  var control = args.control;
  if(control instanceof ASPxClientGridView)
   return;
  var ownerGrid = control.findParentByType(ASPxClientGridView);
  if(ownerGrid && ownerGrid !== control)
   ownerGrid.InitializeCommandButtonsInContainer.call(ownerGrid, control.GetMainElement());
 }
});
var dummyGridViewGlobalEventsListener = new ASPxClientGridViewGlobalEventsListener("gvGlobalEventListener");
window.ASPxClientGridView = ASPxClientGridView;
window.ASPxClientGridViewColumn = ASPxClientGridViewColumn;
window.ASPxClientGridViewColumnCancelEventArgs = ASPxClientGridViewColumnCancelEventArgs;
window.ASPxClientGridViewColumnProcessingModeEventArgs = ASPxClientGridViewColumnProcessingModeEventArgs;
window.ASPxClientGridViewRowCancelEventArgs = ASPxClientGridViewRowCancelEventArgs;
window.ASPxClientGridViewSelectionEventArgs = ASPxClientGridViewSelectionEventArgs;
window.ASPxClientGridViewRowClickEventArgs = ASPxClientGridViewRowClickEventArgs;
window.ASPxClientGridViewContextMenuEventArgs = ASPxClientGridViewContextMenuEventArgs;
window.ASPxClientGridViewContextMenuItemClickEventArgs = ASPxClientGridViewContextMenuItemClickEventArgs;
window.ASPxClientGridViewCustomButtonEventArgs = ASPxClientGridViewCustomButtonEventArgs;
window.ASPxClientGridViewColumnMovingEventArgs = ASPxClientGridViewColumnMovingEventArgs;
window.ASPxClientGridViewBatchEditConfirmShowingEventArgs = ASPxClientGridViewBatchEditConfirmShowingEventArgs;
window.ASPxClientGridViewBatchEditStartEditingEventArgs = ASPxClientGridViewBatchEditStartEditingEventArgs;
window.ASPxClientGridViewBatchEditEndEditingEventArgs = ASPxClientGridViewBatchEditEndEditingEventArgs;
window.ASPxClientGridViewBatchEditRowValidatingEventArgs = ASPxClientGridViewBatchEditRowValidatingEventArgs;
window.ASPxClientGridViewBatchEditTemplateCellFocusedEventArgs = ASPxClientGridViewBatchEditTemplateCellFocusedEventArgs;
window.ASPxClientGridViewBatchEditChangesSavingEventArgs = ASPxClientGridViewBatchEditChangesSavingEventArgs;
window.ASPxClientGridViewBatchEditChangesCancelingEventArgs = ASPxClientGridViewBatchEditChangesCancelingEventArgs;
window.ASPxClientGridViewBatchEditRowInsertingEventArgs = ASPxClientGridViewBatchEditRowInsertingEventArgs;
window.ASPxClientGridViewBatchEditRowDeletingEventArgs = ASPxClientGridViewBatchEditRowDeletingEventArgs;
window.ASPxClientGridViewBatchEditRowRecoveringEventArgs = ASPxClientGridViewBatchEditRowRecoveringEventArgs;
window.ASPxClientGridViewFocusedCellChangingEventArgs = ASPxClientGridViewFocusedCellChangingEventArgs;
ASPx.GridViewHeaderMatrix = GridViewHeaderMatrix;
ASPx.GridViewKbdHelper = GridViewKbdHelper;
ASPx.GridViewConsts = GridViewConsts;
ASPx.GridViewRowType = GridViewRowType;
ASPx.GridViewCallbackHelper = GridViewCallbackHelper;
ASPx.GridViewAdaptiveDetailButtonPosition = GridViewAdaptiveDetailButtonPosition;
ASPx.GetGridViewAdjuster = GetGridViewAdjuster;
ASPx.GridViewStyleHelper = GridViewStyleHelper;
window.ASPxClientGridViewBatchEditApi = ASPxClientGridViewBatchEditApi;
window.ASPxClientGridViewCellInfo = ASPxClientGridViewCellInfo;
window.ASPxClientGridViewExportFormat = ASPx.ASPxClientGridExportFormat;
})();
